Package: datazoom.social
Title: Simplify Access to Brazilian Social Data
Version: 0.1.0
Authors@R: c(
    person("Laura", "Tavares Regadas", , "lauratregadas@gmail.com", role = c("aut", "cre")),
    person("DataZoom (PUC-Rio)", , , "datazoom@econ.puc-rio.br", role = "fnd"),
    person("Igor", "Rigolon Veiga", , "igor.rilave@hotmail.com", role = "aut"),
    person("Arthur", "Lins de Vasconcellos", , "tuca1211@gmail.com", role = "aut"),
    person("Giulia", "Toscano Imbuzeiro", , "giuliatoscano.imbuzeiro@gmail.com", role = "aut"),
    person("Guilherme", "Jardim", , "gnjardim1@gmail.com", role = "aut"),
    person("Pablo", "Chaves", , "pablochavescastro@gmail.com", role = "aut"),
    person("Breno", "Avidos", , "breno.avidos@gmail.com", role = "aut"),
    person("Bernardo", "Sieira", , "bernardo.sieira@gmail.com", role = "aut")
  )
Description: Provides tools for downloading and processing microdata from 
    the PNAD Contínua (PNADC, Continuous National Household Sample Survey), 
    a rotating panel survey published quarterly by IBGE (Brazilian Institute 
    of Geography and Statistics). Includes panel identification algorithms 
    for linking individuals across survey waves.
License: MIT + file LICENSE
URL: https://datazoom.com.br/en/
Imports: arrow, data.table, dplyr, magrittr, PNADcIBGE, purrr, readr,
        rlang, stringr, tidyr
Encoding: UTF-8
RoxygenNote: 7.3.3
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
Depends: R (>= 4.1.0)
BugReports: https://github.com/datazoompuc/datazoom.social/issues
LazyData: true
NeedsCompilation: no
Packaged: 2026-05-04 14:18:36 UTC; Bernardo
Author: Laura Tavares Regadas [aut, cre],
  DataZoom (PUC-Rio) [fnd],
  Igor Rigolon Veiga [aut],
  Arthur Lins de Vasconcellos [aut],
  Giulia Toscano Imbuzeiro [aut],
  Guilherme Jardim [aut],
  Pablo Chaves [aut],
  Breno Avidos [aut],
  Bernardo Sieira [aut]
Maintainer: Laura Tavares Regadas <lauratregadas@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-07 16:01:37 UTC
Built: R 4.5.2; ; 2026-05-07 16:41:22 UTC; unix

Package: datazoom.social
Title: Simplify Access to Brazilian Social Data
Version: 0.1.1
Authors@R: c(
    person("Laura", "Tavares Regadas", , "lauratregadas@gmail.com", role = c("aut", "cre")),
    person("DataZoom (PUC-Rio)", , , "datazoom@econ.puc-rio.br", role = "fnd"),
    person("Igor", "Rigolon Veiga", , "igor.rilave@hotmail.com", role = "aut"),
    person("Arthur", "Lins de Vasconcellos", , "tuca1211@gmail.com", role = "aut"),
    person("Giulia", "Toscano Imbuzeiro", , "giuliatoscano.imbuzeiro@gmail.com", role = "aut"),
    person("Guilherme", "Jardim", , "gnjardim1@gmail.com", role = "aut"),
    person("Pablo", "Chaves", , "pablochavescastro@gmail.com", role = "aut"),
    person("Breno", "Avidos", , "breno.avidos@gmail.com", role = "aut"),
    person("Bernardo", "Sieira", , "bernardo.sieira@gmail.com", role = "aut")
  )
Description: Provides tools for downloading and processing microdata from 
    the PNAD Contínua (PNADC, Continuous National Household Sample Survey), 
    a rotating panel survey published quarterly by IBGE (Brazilian Institute 
    of Geography and Statistics). Includes panel identification algorithms 
    for linking individuals across survey waves.
License: MIT + file LICENSE
URL: https://datazoom.com.br/en/
Imports: arrow, dplyr, igraph, magrittr, PNADcIBGE, purrr, rlang,
        stringr, tidyr
Encoding: UTF-8
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
Depends: R (>= 4.1.0)
BugReports: https://github.com/datazoompuc/datazoom.social/issues
LazyData: true
Config/roxygen2/version: 8.0.0
NeedsCompilation: no
Packaged: 2026-07-06 04:16:10 UTC; luanalaport
Author: Laura Tavares Regadas [aut, cre],
  DataZoom (PUC-Rio) [fnd],
  Igor Rigolon Veiga [aut],
  Arthur Lins de Vasconcellos [aut],
  Giulia Toscano Imbuzeiro [aut],
  Guilherme Jardim [aut],
  Pablo Chaves [aut],
  Breno Avidos [aut],
  Bernardo Sieira [aut]
Maintainer: Laura Tavares Regadas <lauratregadas@gmail.com>
Repository: CRAN
Date/Publication: 2026-07-06 15:40:02 UTC

<a href="https://github.com/datazoompuc/datazoom.social"><img src="https://raw.githubusercontent.com/datazoompuc/datazoom.social/master/logo_hex.png" align="left" width="100" hspace="10" vspace="6"></a>

<!-- README.md is generated from README.Rmd. Please edit that file -->

# datazoom.social

<!-- badges: start -->

![Languages](https://img.shields.io/github/languages/count/datazoompuc/datazoom.social?style=flat)
![Commits](https://img.shields.io/github/commit-activity/y/datazoompuc/datazoom.social?style=flat)
![Open
Issues](https://img.shields.io/github/issues-raw/datazoompuc/datazoom.social?style=flat)
![Closed
Issues](https://img.shields.io/github/issues-closed-raw/datazoompuc/datazoom.social?style=flat)
![Files](https://img.shields.io/github/directory-file-count/datazoompuc/datazoom.social?style=flat)
![Followers](https://img.shields.io/github/followers/datazoompuc?style=flat)
<!-- badges: end -->

The datazoom.social package facilitates access to official Brazilian
social data.

This package is in development stage - more datasets will be released
soon.

In this first version of the package, the focus is only on the
[Continuous
PNAD](https://www.ibge.gov.br/estatisticas/sociais/populacao/9173-pesquisa-nacional-por-amostra-de-domicilios-continua-trimestral.html).
We allow for many quarters to be easily downloaded and read, as well as
identifying individuals across time, forming a panel.

# Installation

<!-- You can install the released version of `datazoom.social` from -->
<!-- [CRAN](https://CRAN.R-project.org/package=datazoom.social) with: -->
<!-- ``` {r, eval=FALSE} -->
<!-- install.packages("datazoom.social") -->
<!-- ``` -->

You can install the development version of `datazoom.social` from GitHub
with:

``` r
install.packages("devtools")
devtools::install_github("datazoompuc/datazoom.social")
```

## Data

<table>
<tr>
<td>

|                                                        |                                         |
|--------------------------------------------------------|-----------------------------------------|
| **[Continuous PNAD](#continuous-pnad)**                | *Download PNADC of a range of quarters* |
| **[Panel Identification](#pnad-panel-identification)** | *Build a Panel of PNADC individuals*    |

</td>
</tr>
</table>

## Continuous PNAD

The `load_pnadc` function is a wrapper for
[*`get_pnadc`*](https://www.rdocumentation.org/packages/PNADcIBGE/versions/0.7.0/topics/get_pnadc)
from the package `PNADcIBGE`, with added identification algorithms for
panel construction. For details on the identification algorithms, see
`vignette("BUILD_PNADC_PANEL")`.

------------------------------------------------------------------------

**Panel Structure:**

The table below shows the first and last quarter (`ANOtrimestre`, e.g.
`20121` = 2012 Q1) covered by each PNADC rotating panel:

| Panel | Start |   End |
|------:|------:|------:|
|     1 | 20121 | 20124 |
|     2 | 20121 | 20141 |
|     3 | 20132 | 20152 |
|     4 | 20143 | 20163 |
|     5 | 20154 | 20174 |
|     6 | 20171 | 20191 |
|     7 | 20182 | 20202 |
|     8 | 20193 | 20213 |
|     9 | 20204 | 20224 |
|    10 | 20221 | 20241 |
|    11 | 20232 | 20252 |
|    12 | 20243 | 20263 |
|    13 | 20254 | 20274 |
|    14 | 20271 | 20291 |

------------------------------------------------------------------------

**Usage:**

Default

``` r

load_pnadc(
  save_to = getwd(),
  years,
  quarters = 1:4,
  panel = "advanced",
  raw_data = FALSE,
  save_options = c(TRUE, TRUE),
  vars = NULL
)
```

To download PNADC data for all quarters of 2022 and 2023, with advanced
identification, simply run

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022:2023
)
```

To download PNADC data for all of 2022, but only the first quarter of
2023, run

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022:2023,
  quarters = list(1:4, 1)
)
```

To download PNADC data without any variables treatment or identification
(e.g., for all quarters of 2021), run

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2021,
  panel = "none",
  raw_data = TRUE
)
```

To download PNADC data, keep the quarters parquet on disk, and save
panels as Parquet, run

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  save_options = c(TRUE, FALSE)
)
```

To download PNADC data and save panels as CSV but discard the
intermediate quarters parquet, run

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  save_options = c(FALSE, TRUE)
)
```

To download only a specific subset of variables — for example, age
(`V2009`) and habitual income (`VD4019`) — alongside the structural
columns that `PNADcIBGE` always returns, run

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  vars = c("V2009", "VD4019")
)
```

> **Note:** `PNADcIBGE::get_pnadc()` always downloads a set of ~210
> structural columns regardless of the `vars` argument. These include
> survey design weights (`V1027`, `V1028`, `V1028001`–`V1028200`,
> `posest`, `posest_sxi`), deflator variables (`Habitual`, `Efetivo`),
> and identifiers such as `UF`, `Estrato`, `V1029`, `V1033`, and
> `ID_DOMICILIO`. The `vars` argument adds columns **on top of** those;
> it does not restrict them. Use `vars = NULL` (the default) to download
> all available microdata columns.

If you specify `vars` and also request panel identification, any columns
required by the identification algorithm that are absent from `vars`
will be added automatically and a warning will tell you which ones were
added. For example, when using `panel = "advanced"`, the columns
`V2007`, `V20082`, `V20081`, `V2008`, and `V2003` must be present. If
you omit them from `vars`, the function adds them for you:

``` r
# Only V2009 requested, but panel = "advanced" (the default) needs
# V2007, V20082, V20081, V2008 and V2003 — these are added automatically
# with a warning.
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  panel = "advanced",
  vars = c("V2009", "VD4019")
)
```

------------------------------------------------------------------------

**Options:**

1.  **save_to**: The directory in which the user desires to save the
    downloaded files.

2.  **years**: picks the years for which the data will be downloaded

3.  **quarters**: The quarters within those years to be downloaded. Can
    be either a vector such as `1:4` for consistent quarters across
    years, or a list of vectors, if quarters are different for each year
    (e.g. `list(1:4, 1:2)` for four quarters in the first year and two
    in the second).

4.  **panel**: Which panel algorithm to apply to this data. There are
    three options:

    - `none`: No panel is built. If `raw_data = TRUE`, returns the
      original data. Otherwise, creates some extra treated variables.
      The intermediate quarters parquet is always kept when
      `panel = "none"`.
    - `basic`: Performs basic identification steps for creating
      households and individual identifiers for panel construction
    - `advanced`: Performs advanced identification steps for creating
      households and individual identifiers for panel construction.

5.  **raw_data**: A command to define if the user would like to download
    the raw or treated data. There are two options:

    - `TRUE`: if you want the PNADC variables as they come.
    - `FALSE`: if you want the treated version of the PNADC variables.

6.  **save_options**: A logical vector of length 2 controlling file
    saving behaviour:

    - `c(TRUE, TRUE)` (default): keeps the intermediate quarters parquet
      after panel is built; saves panel files as `.csv`.
    - `c(FALSE, TRUE)`: deletes the quarters parquet after use; saves
      panel files as `.csv`.
    - `c(TRUE, FALSE)`: keeps the quarters parquet; saves panel files as
      a `.parquet` dataset.
    - `c(FALSE, FALSE)`: deletes the quarters parquet after use; saves
      panel files as a `.parquet` dataset.

7.  **vars**: A character vector of additional variable names to
    download, following the same convention as `vars` in
    `PNADcIBGE::get_pnadc()`. Use `NULL` (the default) to download all
    available microdata columns. See the note above regarding the ~210
    structural columns that are always returned by
    `PNADcIBGE::get_pnadc()` regardless of this argument.

------------------------------------------------------------------------

**Details:**

The function performs the following steps:

1.  Loop over years and quarters using `PNADcIBGE::get_pnadc` to
    download the data. All quarters are collected in memory and saved
    together into a single `pnadc_quarters.parquet` file in `save_to`.

2.  Split the data into panels by the panel variable `V1014`. Data from
    each panel is saved depending on `save_options`.

3.  Read each panel file and apply the identification algorithms defined
    in `build_pnadc_panel`.

4.  If `save_options[1] = FALSE`, the intermediate quarters parquet is
    deleted after the panels are built.

- The identification algorithms in `build_pnadc_panel` are drawn from
  Ribas, Rafael Perez, and Sergei Suarez Dillon Soares (2008): “Sobre o
  painel da Pesquisa Mensal de Emprego (PME) do IBGE”.

------------------------------------------------------------------------

------------------------------------------------------------------------

## PNAD Panel Identification

------------------------------------------------------------------------

**Usage:**

Basic Panel

``` r

panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "basic")
```

Advanced Panel

``` r

panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced")
```

------------------------------------------------------------------------

**Description**

Our `load_pnadc` function uses the internal function `build_pnadc_panel`
to identify households and individuals across quarters. The method used
for the identification is based on the paper of Ribas, Rafael Perez, and
Sergei Suarez Dillon Soares (2008): “Sobre o painel da Pesquisa Mensal
de Emprego (PME) do IBGE”.

------------------------------------------------------------------------

## Basic Identification

The household identifier – stored as `id_dom` – combines the variables:

- `UPA` – Primary Sampling Unit - PSU;

- `V1008` – Household;

- `V1014` – Panel Number;

In order to create a unique number for every combination of those
variables.

------------------------------------------------------------------------

The basic individual identifier – stored as `id_ind` – combines the
household id with:

- `V2007` – Sex;

- Date of Birth – \[`V20082` (year), `V20081` (month), `V2008` (day)\];

In order to create an unique number for every combination of those
variables.

------------------------------------------------------------------------

## Advanced Identification

The advanced identifier is saved as `id_rs`. On individuals who were not
matched on all interviews, we relax some assumptions to increase
matching power. Under the assumption that the date of birth is often
misreported, we take individuals who are either:

1.  Head of the household or their partner

2.  Child of the head of the household, 25 or older

For these observations, we run the basic identification again, but
allowing the year of birth to be wrong. We also include the order
number.

## Attrition

The tables below show the levels of attrition obtained using the basic
and advanced identification algorithms, and compares them to the
attrition levels obtained in the Stata `datazoom_social` package.

| Interview | Percentage found (R) | Percentage found (Stata) |
|----------:|---------------------:|-------------------------:|
|         1 |                100.0 |                    100.0 |
|         2 |                 86.2 |                     85.7 |
|         3 |                 78.5 |                     77.5 |
|         4 |                 73.2 |                     71.6 |
|         5 |                 69.1 |                     66.8 |

Attrition for Panel 2

Each cell is the percentage of PNADC observations that are identified by
the advanced algorithm in each interview.

------------------------------------------------------------------------

# Credits

DataZoom is developed by a team at Pontifícia Universidade Católica do
Rio de Janeiro (PUC-Rio), Department of Economics. Our official website
is at: <https://datazoom.com.br/en/>.

To cite package `datazoom.social` in publications use:

> Data Zoom (2023). Data Zoom: Simplifying Access To Brazilian
> Microdata.  
> <https://datazoom.com.br/en/>

A BibTeX entry for LaTeX users is:

    @Unpublished{DataZoom2024,
        author = {Data Zoom},
        title = {Data Zoom: Simplifying Access To Brazilian Microdata},
        url = {https://datazoom.com.br/en/},
        year = {2024}}

<a href="https://github.com/datazoompuc/datazoom.social"><img src="https://raw.githubusercontent.com/datazoompuc/datazoom.social/master/logo_hex.png" align="left" width="100" hspace="10" vspace="6"></a>

<!-- README.md is generated from README.Rmd. Please edit .Rmd file -->

# datazoom.social

<!-- badges: start -->

[![CRAN
status](https://www.r-pkg.org/badges/version/datazoom.social)](https://CRAN.R-project.org/package=datazoom.social)
[![CRAN RStudio mirror
downloads](https://cranlogs.r-pkg.org/badges/grand-total/datazoom.social)](https://CRAN.R-project.org/package=datazoom.social)
[![CRAN RStudio mirror
downloads](https://cranlogs.r-pkg.org/badges/datazoom.social)](https://CRAN.R-project.org/package=datazoom.social)
![Languages](https://img.shields.io/github/languages/count/datazoompuc/datazoom.social?style=flat)
![Commits](https://img.shields.io/github/commit-activity/y/datazoompuc/datazoom.social?style=flat)
![Open
Issues](https://img.shields.io/github/issues-raw/datazoompuc/datazoom.social?style=flat)
![Closed
Issues](https://img.shields.io/github/issues-closed-raw/datazoompuc/datazoom.social?style=flat)
![Files](https://img.shields.io/github/directory-file-count/datazoompuc/datazoom.social?style=flat)
![Followers](https://img.shields.io/github/followers/datazoompuc?style=flat)
<!-- badges: end -->

The datazoom.social package facilitates access to official Brazilian
social data.

This package is in development: more datasets will be added soon.

In the first version of the package, the focus is on the [Continuous
PNAD](https://www.ibge.gov.br/estatisticas/sociais/populacao/9173-pesquisa-nacional-por-amostra-de-domicilios-continua-trimestral.html)
panel. We allow for many quarters to be easily downloaded and read, and
provide identification of individuals across time forming a panel.

# Installation

You can install the released version of `datazoom.social` from
[CRAN](https://CRAN.R-project.org/package=datazoom.social) with:

``` r
install.packages("datazoom.social")
```

You can install the development version of `datazoom.social` from GitHub
with:

``` r
install.packages("devtools")
devtools::install_github("datazoompuc/datazoom.social")
```

## Data

<table>

<tr>

<td>

|  |  |
|----|----|
| **[`load_pnadc`](#continuous-pnad)** | *Download PNADC of a range of quarters* |
| **[`build_pnadc_panel`](#pnad-panel-identification)** | *Identify individuals throughout time* |

</td>

</tr>

</table>

## Continuous PNAD

The `load_pnadc` function is a wrapper for
*[`get_pnadc`](https://www.rdocumentation.org/packages/PNADcIBGE/versions/0.7.0/topics/get_pnadc)*
from the package `PNADcIBGE`, with added identification algorithms for
panel construction. For details on the identification algorithms, see
`vignette("BUILD_PNADC_PANEL")`.

------------------------------------------------------------------------

**Panel Structure:**

The table below shows the first and last quarter (`ANOtrimestre`,
e.g. `20121` = 2012 Q1) covered by each PNADC rotating panel:

| Panel | Start | End   |
|------:|-------|-------|
|     1 | 20121 | 20124 |
|     2 | 20121 | 20141 |
|     3 | 20132 | 20152 |
|     4 | 20143 | 20163 |
|     5 | 20154 | 20174 |
|     6 | 20171 | 20191 |
|     7 | 20182 | 20202 |
|     8 | 20193 | 20213 |
|     9 | 20204 | 20224 |
|    10 | 20221 | 20241 |
|    11 | 20232 | 20252 |
|    12 | 20243 | 20263 |
|    13 | 20254 | 20274 |
|    14 | 20271 | 20291 |

------------------------------------------------------------------------

**Usage:**

Default:

``` r

load_pnadc(
  save_to = getwd(),
  years,
  quarters = 1:4,
  panel = "advanced_3",
  raw_data = FALSE,
  save_options = c(TRUE, TRUE),
  vars = NULL
)
```

To download PNADC data for all quarters of 2022 and 2023, with advanced
fuzzy identification (Stage 3), simply run:

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022:2023,
  panel = "advanced_3"
)
```

To download PNADC data for all of 2022, but only the first quarter of
2023, run:

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022:2023,
  quarters = list(1:4, 1)
)
```

To download PNADC data without any variables treatment or identification
(e.g., for all quarters of 2021), run:

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2021,
  panel = "none",
  raw_data = TRUE
)
```

To download PNADC data, save quarters on disk, and save panels as
Parquet, run:

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  save_options = c(TRUE, FALSE)
)
```

To download PNADC data and save panels as RDS but discard the quarterly
files, run:

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  save_options = c(FALSE, TRUE)
)
```

To download only a specific subset of variables — for example, age
(`V2009`) and habitual income (`VD4019`) — alongside the structural
columns that `PNADcIBGE` always returns, run:

``` r
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  vars = c("V2009", "VD4019")
)
```

> **Note:** `PNADcIBGE::get_pnadc()` always downloads a set of ~210
> structural columns regardless of the `vars` argument. These include
> survey design weights (`V1027`, `V1028`, `V1028001`–`V1028200`,
> `posest`, `posest_sxi`), deflator variables (`Habitual`, `Efetivo`),
> and identifiers such as `UF`, `Estrato`, `V1029`, `V1033`, and
> `ID_DOMICILIO`. The `vars` argument adds columns **on top of** those;
> it does not restrict them. Use `vars = NULL` (the default) to download
> all available microdata columns.

If you specify `vars` and also request panel identification, any columns
required by the identification algorithm that are absent from `vars`
will be added automatically and a warning will tell you which ones were
added. For example, when using `panel = "advanced_3"`, the columns
`V2007`, `V20082`, `V20081`, `V2008`, and `V2003` must be present. If
you omit them from `vars`, the function adds them for you:

``` r
# Only V2009 requested, but panel = "advanced_3" needs
# V2007, V20082, V20081, V2008 and V2003 — these are added automatically
# with a warning.
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  panel = "advanced_3",
  vars = c("V2009", "VD4019")
)
```

------------------------------------------------------------------------

**Options:**

1.  **save_to**: The directory in which the user desires to save the
    downloaded files.

2.  **years**: picks the years for which the data will be downloaded

3.  **quarters**: The quarters within those years to be downloaded. Can
    be either a vector such as `1:4` for consistent quarters across
    years, or a list of vectors, if quarters are different for each year
    (e.g. `list(1:4, 1:2)` for four quarters in the first year and two
    in the second).

4.  **panel**: Which panel algorithm to apply to this data. There are
    five options:

    - `none`: No panel is built. If `raw_data = TRUE`, returns the
      original data. Otherwise, creates some extra treated variables.
      Quarterly files are saved depending on `save_options`.
    - `basic`: Performs basic identification steps using household IDs,
      sex, and exact dates of birth.
    - `advanced_1`: Performs Stage 1 advanced identification, imputing
      missing birth dates using within-household donors.
    - `advanced_2`: Performs Stage 2 advanced identification, relaxing
      the year of birth constraint.
    - `advanced_3` (Recommended): Performs Stage 3 advanced
      identification, utilizing Graph Theory for fuzzy matching of
      fragmented interviews to account for typographical errors.

5.  **raw_data**: A command to define if the user would like to download
    the raw or treated data. There are two options:

    - `TRUE`: if you want the PNADC variables as they come.
    - `FALSE`: if you want the treated version of the PNADC variables.

6.  **save_options**: A logical vector of length 2 controlling file
    saving behavior:

    - `c(TRUE, TRUE)` (default): saves quarterly and panel files as
      `.rds`.
    - `c(FALSE, TRUE)`: does not save quarterly files; saves panel files
      as `.rds`.
    - `c(TRUE, FALSE)`: saves quarterly and panel files as `.parquet`
      datasets.
    - `c(FALSE, FALSE)`: does not save quarterly files; saves panel
      files as a `.parquet` dataset.

7.  **vars**: A character vector of additional variable names to
    download, following the same convention as `vars` in
    `PNADcIBGE::get_pnadc()`. Use `NULL` (the default) to download all
    available microdata columns. See the note above regarding the ~210
    structural columns that are always returned by
    `PNADcIBGE::get_pnadc()` regardless of this argument

------------------------------------------------------------------------

**Details:**

The function performs the following steps:

1.  Loop over years and quarters using `PNADcIBGE::get_pnadc` to
    download the data. All quarters are collected in memory and saved
    depending on `save_options`.
2.  Split the data into panels by the panel variable `V1014`.
3.  Apply the identification algorithms defined in `build_pnadc_panel`.
4.  Save the panel files as `.rds` or `.parquet`, depending on
    `save_options`.

- The base identification logic in `build_pnadc_panel` was originally
  drawn from Ribas, Rafael Perez, and Sergei Suarez Dillon Soares
  (2008): “Sobre o painel da Pesquisa Mensal de Emprego (PME) do IBGE”,
  with extensive modernizations, missing-data imputation, and
  graph-based fuzzy matching introduced by the Data Zoom team.

------------------------------------------------------------------------

------------------------------------------------------------------------

## PNAD Panel Identification

------------------------------------------------------------------------

**Usage:**

Basic Panel:

``` r
panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "basic")
```

Advanced Panel (Stages 1, 2, or 3):

``` r
# Stage 1: Exact matching with donated birth dates
panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced_1")

# Stage 2: Relaxed matching constraints
panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced_2")

# Stage 3: Fuzzy matching using Graph Theory (Recommended)
panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced_3")
```

------------------------------------------------------------------------

**Description**

Our `load_pnadc` function uses the internal function `build_pnadc_panel`
to identify households and individuals across quarters. The base method
used for the identification draws from the paper of Ribas, Rafael Perez,
and Sergei Suarez Dillon Soares (2008): “Sobre o painel da Pesquisa
Mensal de Emprego (PME) do IBGE”, with modernizations implemented by the
Data Zoom team to handle missing data and typographical errors.

------------------------------------------------------------------------

## Basic Identification

The household identifier – stored as `id_dom` – combines the variables:

- `UPA` – Primary Sampling Unit - PSU;
- `V1008` – Household;
- `V1014` – Panel Number;

In order to create a unique number for every combination of those
variables.

------------------------------------------------------------------------

The basic individual identifier – stored as `id_ind` – combines the
household id with:

- `V2007` – Sex;
- Date of Birth – \[`V20082` (year), `V20081` (month), `V2008` (day)\];

In order to create a unique number for every combination of those
variables.

------------------------------------------------------------------------

## Advanced Identification

On individuals who were not matched across all interviews using the
basic method, we apply a progressive multi-stage algorithm to increase
matching power without compromising uniqueness.

- **Stage 1 (`advanced_1`):** We reproduce the birth date donation
  method (Osório, 2019). It estimates and imputes missing birth dates
  (day, month, and year) by matching individuals with donors from
  different interviews within the same household based on sex,
  acceptable household condition changes, and estimated age. The
  identifier is stored as `id_rs1`.
- **Stage 2 (`advanced_2`):** For individuals not completely matched in
  Stage 1, we relax the year of birth constraint (assuming it is often
  misreported) and match individuals based on Household ID, Month, and
  Day of birth. The identifier is stored as `id_rs2`.
- **Stage 3 (`advanced_3`):** Applies a rigorous Fuzzy Matching
  algorithm using Graph Theory (via the `igraph` package). Targeting
  candidates with fragmented interviews, it evaluates pairwise
  combinations within the same household. It tolerates small
  typographical errors (up to 4 days difference in the day of birth, 2
  months in the month of birth) and dynamically adjusts the acceptable
  year-of-birth difference based on the individual’s reported age. The
  final identifier is stored as `id_rs3`.

## Identification Rates

The table below shows the average unconditional tracking rates (base
line) obtained using the basic and advanced identification algorithms
across multiple panels.

*Note: Following the Data Zoom methodological guidelines, we reserve the
term **Attrition** strictly for the dropout of households. When
referring to individuals (people), we use the term **Identification
Rate**. Wave 1 represents the pure initial identification rate (data
lost exclusively due to the inability to construct a valid identifier or
household grouping constraints). The subsequent waves (2 to 5) represent
the cumulative loss of tracked data over time.*

| Interview (Wave) | Basic Rate (%) | Adv 1 Rate (%) | Adv 2 Rate (%) | Adv 3 Rate (%) | Difference (Adv 3 - Basic) |
|:--:|:--:|:--:|:--:|:--:|:--:|
| 1 | 93.82378 | 95.82954 | 96.40170 | 96.39606 | \+ 2.57228 p.p. |
| 2 | 81.63945 | 84.52960 | 85.32100 | 85.63223 | \+ 3.99278 p.p. |
| 3 | 75.58231 | 78.90345 | 79.87407 | 80.37762 | \+ 4.79531 p.p. |
| 4 | 71.13217 | 74.66729 | 75.75082 | 76.39818 | \+ 5.26601 p.p. |
| 5 | 67.56865 | 71.18041 | 72.31560 | 73.06694 | \+ 5.49829 p.p. |

Each cell in the rate columns represents the percentage of raw PNADC
individual observations successfully identified and tracked in that
specific interview, using the total number of raw lines from Wave 1 as
the universal denominator.

------------------------------------------------------------------------

# Credits

DataZoom is developed by a team at Pontifícia Universidade Católica do
Rio de Janeiro (PUC-Rio), Department of Economics. Our official website
is at: <https://datazoom.com.br/en/>.

To cite package `datazoom.social` in publications use:

> Data Zoom (2023). Data Zoom: Simplifying Access To Brazilian
> Microdata.  
> <https://datazoom.com.br/en/>

A BibTeX entry for LaTeX users is:

    @Unpublished{DataZoom2024,
        author = {Data Zoom},
        title = {Data Zoom: Simplifying Access To Brazilian Microdata},
        url = {https://datazoom.com.br/en/},
        year = {2024}}

.onAttach <- function(libname, pkgname) {
  packageStartupMessage("Please cite as: ")
  packageStartupMessage("Data Zoom (2023). Data Zoom: Simplifying Access To Brazilian Microdata.
https://datazoom.com.br/en/")

  packageStartupMessage("\nOr if you prefer a BibTeX entry: ")
  packageStartupMessage("@Unpublished{DataZoom2023,
	     author = {Data Zoom},
	     title = {Data Zoom: Simplifying Access To Brazilian Microdata},
	     url = {https://datazoom.com.br/en/},
	     year = {2023},
}")
}

#' Load Continuous PNAD Data
#'
#' This function downloads PNADC data and applies panel identification algorithms
#'
#' @param save_to A \code{character} with the directory in which to save the downloaded files.
#' @param years A \code{numeric} indicating for which years the data will be loaded, in the format YYYY. Can be any vector of numbers, such as 2010:2012.
#' @param quarters The quarters within those years to be downloaded. Can be a numeric vector or a list of vectors, for different quarters per year.
#' @param panel A \code{character} choosing the panel algorithm to apply ("none", "basic", or "advanced"). For details, check \code{vignette("BUILD_PNADC_PANEL")}
#' @param raw_data A \code{logical} setting the return of raw (\code{TRUE}) or processed (\code{FALSE}) variables.
#' @param save_options A \code{logical} vector of length 2. Controls whether quarterly
#'   files are saved and in which format all files are saved. Panel files are
#'   always saved. There are four possible combinations:
#'   \itemize{
#'     \item \code{c(TRUE, TRUE)}: saves quarterly and panel files in
#'       \code{.rds} format. This is the default.
#'     \item \code{c(TRUE, FALSE)}: saves quarterly and panel files in
#'       \code{.parquet} format.
#'     \item \code{c(FALSE, TRUE)}: does not save quarterly files; panel files
#'       are saved in \code{.rds} format.
#'     \item \code{c(FALSE, FALSE)}: does not save quarterly files; panel files
#'       are saved in \code{.parquet} format.
#'   }
#' @param vars A \code{character} vector of additional variable names to be
#'   downloaded, following the same convention as the \code{vars} parameter in
#'   \code{\link[PNADcIBGE]{get_pnadc}}. Each name must match a column in the
#'   PNADC microdata exactly as published by IBGE (e.g. \code{"VD4019"},
#'   \code{"V2009"}).
#'
#'   Note that \code{\link[PNADcIBGE]{get_pnadc}} always returns a set of
#'   structural columns regardless of this argument, these include survey
#'   design weights (\code{V1027}, \code{V1028}, \code{V1028001}, \code{V1028200},
#'   \code{posest}, \code{posest_sxi}), deflator variables (\code{Habitual},
#'   \code{Efetivo}), and identifiers such as \code{UF}, \code{Estrato},
#'   \code{V1029}, \code{V1033}, \code{ID_DOMICILIO}, totalling around 233
#'   columns. The \code{vars} argument adds \emph{on top of} those columns;
#'   it does not restrict them. Use \code{NULL} (the default) to download all
#'   available microdata columns.
#'
#'   If \code{panel} is not \code{"none"}, any columns required by the panel
#'   identification algorithm that are missing from \code{vars} will be added
#'   automatically and a \code{\link{warning}} will list the columns that were
#'   added. The required columns per algorithm are:
#'   \itemize{
#'     \item \code{"basic"}: \code{UPA}, \code{V1008}, \code{V1014},
#'       \code{V2007}, \code{V20082}, \code{V20081}, \code{V2008}.
#'     \item \code{"advanced"}: all of the above, plus \code{V2003}.
#'   }
#'   Note that several of these (\code{UPA}, \code{V1008}, \code{V1014}) are
#'   part of the structural columns always returned by
#'   \code{\link[PNADcIBGE]{get_pnadc}}, so in practice only \code{V2007},
#'   \code{V20082}, \code{V20081}, \code{V2008} (and \code{V2003} for
#'   \code{"advanced"}) are likely to be auto-added.
#'
#' @return A message indicating the successful save of panel files.
#'
#' @import PNADcIBGE
#' @importFrom magrittr `%>%`
#'
#' @examplesIf interactive()
#' ### DO NOT RUN ###
#' load_pnadc(
#'   save_to = tempdir(),
#'   years = 2016,
#'   quarters = 1:4,
#'   panel = "advanced",
#'   raw_data = FALSE,
#'   save_options = c(FALSE, FALSE)
#' )
#' @export

load_pnadc <- function(save_to, years,
                       quarters = 1:4, panel = "advanced",
                       raw_data = FALSE, save_options = c(TRUE, TRUE),
                       vars = NULL) {
  
  if (missing(save_to) || is.null(save_to) || !nzchar(save_to)) {
    stop("'save_to' must be a non-empty path to an existing directory.", call. = FALSE)
  }
  if (!dir.exists(save_to)) {
    stop("Directory '", save_to, "' does not exist. Please create it first.", call. = FALSE)
  }
  
  # Check if PNADcIBGE namespace is already attached
  if (!"PNADcIBGE" %in% .packages()) {
    # If not attached, attach it
    attachNamespace("PNADcIBGE") # without this, an error appears
    # I believe this is a problem with the PNADcIBGE package
    # If you run PNADcIBGE::get_pnad(...) without library(PNADcIBGE)
    # you get the same error
  }
  
  # if (!requireNamespace("PNADcIBGE", quietly = TRUE)) {
  #   stop(
  #     "Please run library(PNADcIBGE) before using this function.",
  #     call. = FALSE
  #   )
  # }
  
  ###########################
  ## Bind Global Variables ##
  ###########################
  
  year <- . <- V1014 <- Ano <- Trimestre <- NULL
  
  #############################
  ## Define Basic Parameters ##
  #############################
  
  # The param list contains the various objects that will be used as parameters for this function
  param <- list()
  param$years     <- years     # the years the user would like to download
  param$quarters  <- quarters  # the quarters within those years to be downloaded
  param$panel     <- panel     # which panel algorithm (none, basic or advanced) should be applied to this data, check our READ-ME for greater explanation
  param$raw_data  <- raw_data  # A command to define if the user would like to download the raw data from the IBGE website directly
  param$save_to   <- save_to   # the directory in which the user desires to save the files downloaded
  param$save_quarters <- save_options[1] # whether to save quarterly files to disk
  param$rds           <- save_options[2] # if TRUE, saves as .rds; if FALSE, saves as .parquet
  
  # Check if quarter is a list; if not, wrap it in a list and repeat it for each year
  if (!is.list(quarters)) {
    param$quarters <- rep(list(quarters), length(years))
  }
  
  # Calculate the lengths of quarters for each year
  n_quarters <- lapply(param$quarters, length)
  
  # Map2: Repeat each year based on the corresponding lengths in n_quarters, so we can have two parallel vectors of years and quarters to loop over
  param$years <- purrr::map2(
    years, n_quarters,
    function(year, n) {
      rep(year, n)
    }
  )
  
  # generaring these two paralell vectors of years and quarter to loop over
  
  param$years    <- unlist(param$years)
  param$quarters <- unlist(param$quarters)
  
  #####################
  ## vars validation ##
  #####################
  
  # Columns required to run the panel identification algorithms.
  # These must always be present in the data regardless of the user's selection.
  panel_required_basic    <- c("UPA", "V1008", "V1014", "V2007", "V20082", "V20081", "V2008")
  panel_required_advanced <- c(panel_required_basic, "V2003")
  
  if (!is.null(vars) && param$panel != "none") {
    required_cols <- if (param$panel == "advanced") panel_required_advanced else panel_required_basic
    missing_cols  <- setdiff(required_cols, vars)
    if (length(missing_cols) > 0) {
      warning(
        "The following columns required for panel identification were not in `vars` ",
        "and have been added automatically: ",
        paste(missing_cols, collapse = ", "),
        ".\n",
        "Note: PNADcIBGE::get_pnadc() always returns ~210 structural columns (weights, ",
        "deflators, identifiers) regardless of `vars`. The `vars` argument only adds ",
        "columns on top of those, it does not restrict them.",
        call. = FALSE
      )
      vars <- c(vars, missing_cols)
    }
  }
  
  ##################
  ## Loading data ##
  ##################
  
  # store info on all panels and column names
  
  panel_list <- c()
  cnames     <- NULL
  
  # download all quarters into a list of data frames
  
  source_files <- purrr::map2(
    param$years, param$quarters, # looping over the two parallel vector of years and quarters (this was previoulsy done in a "for" structure, but qwe optimized it)
    
    function(year, quarter) {
      base::message(paste0("Downloading PNADC ", year, " Q", quarter, "\n"))
      
      df <- get_pnadc(year = year, quarter = quarter, labels = FALSE, design = FALSE, vars = vars)
      
      if (is.null(df)) {
        return(NULL)
        
      } else {
        # turns everything into numeric
        df <- df %>%
          dplyr::mutate(dplyr::across(dplyr::everything(), as.numeric))
        
        panel_list <<- c(panel_list, unique(df$V1014)) # registering, for every quarter, the panel's which the quarter's observations are included (every OBS is just included in one panel, but the data for a quarter contains observations of many panels)
        #<<- stabilishing a variable inside the function that continues to exist outside the function, it is not just local to the function's current context
        
        # runs data cleaning if desired
        if (!param$raw_data) {
          df <- treat_pnadc(df)
        }
        
        cnames <<- names(df)
        
        # tag each row with its year and quarter for later reference
        df$Ano       <- year
        df$Trimestre <- quarter
        
        return(df)
      }
    }
  )
  
  # Remove NULL entries (failed downloads)
  source_files <- purrr::compact(source_files)
  
  # bind all quarters into one data frame
  all_quarters <- purrr::list_rbind(source_files)
  
  # save quarterly files to disk if requested
  if (param$save_quarters) {
    if (param$rds) {
      # RDS: write one flat file per year-quarter
      purrr::map2(
        param$years, param$quarters,
        function(y, q) {
          quarter_df <- all_quarters %>% dplyr::filter(Ano == y, Trimestre == q)
          file_path <- file.path(
            param$save_to, paste0("pnadc_", y, "_", q, ".rds")
          )
          base::message(paste0("Saving ", y, " Q", q, " to\n", file_path, "\n"))
          saveRDS(quarter_df, file_path)
        }
      )
    } else {
      # Parquet: write a partitioned dataset grouped by Ano/Trimestre
      quarters_dir <- file.path(param$save_to, "pnadc_quarters")
      base::message(paste0(
        "Saving quarterly parquet dataset to\n", quarters_dir, "\n"
      ))
      all_quarters %>%
        dplyr::group_by(Ano, Trimestre) %>%
        arrow::write_dataset(
          path = quarters_dir,
          format = "parquet"
        )
    }
  }
  
  ## Return Raw Data
  
  if (param$panel == "none") {
    return(paste("Quarters saved to", param$save_to))
  }
  
  #################
  ## Panel Files ##
  #################
  
  if (param$panel != "none") {
    ## Split data into panels
    
    panel_list <- unique(panel_list) # listing all the panels included in the quarters downloaded
    
    # Apply panel identification to each panel's data
    
    identified_panels <- purrr::map(
      panel_list,
      function(p) {
        base::message(paste("Compiling panel", p, "\n"))
        dat <- all_quarters %>% dplyr::filter(V1014 == p)
        
        message(paste("Running", param$panel, "identification on panel", p, "\n"))
        df <- dat %>%
          build_pnadc_panel(panel = param$panel)
        
        return(df)
      }
    )
    
    # save panel files
    
    if (param$rds) {
      # RDS: write one flat file per panel
      purrr::map2(
        identified_panels, panel_list,
        function(df, p) {
          path <- file.path(param$save_to, paste0("Panel_", p, ".rds"))
          message(paste("Saving panel to", path, "\n"))
          saveRDS(df, path)
        }
      )
    } else {
      # Parquet: bind all panels and write a partitioned dataset grouped by V1014
      all_panels <- purrr::list_rbind(identified_panels)
      panels_dir <- file.path(param$save_to, "pnadc_panels")
      message(paste(
        "Saving partitioned panel parquet dataset to", panels_dir, "\n"
      ))
      all_panels %>%
        dplyr::group_by(V1014) %>%
        arrow::write_dataset(
          path = panels_dir,
          format = "parquet"
        )
    }
  }
  
  ####################
  ## Returning Data ##
  ####################
  
  return(paste("Panel files saved to", param$save_to))
}

######################
## Data Engineering ##
######################

# define a data cleaning function which is run for each quarter separately

treat_pnadc <- function(df) {
  # binding globals
  UF <- regiao <- V2007 <- VD3004 <- VD4019 <- Habitual <- VD4002 <- V4012 <- NULL
  VD4001 <- V2009 <- ocupado <- desocupado <- forca_trab <- VD4005 <- VD4009 <- NULL
  VD4012 <- V4022 <- V4013 <- cnae_2dig <- V4010 <- cod_2dig <- NULL
  V3002 <- V4074 <- V4074A <- fora_forca_trab <- NULL
  
  # regions
  
  if ("UF" %in% names(df)) {
    df <- df %>%
      dplyr::mutate(
        regiao = substr(UF, 1, 1),
        regiao = dplyr::case_match(
          regiao,
          "1" ~ "Norte",
          "2" ~ "Nordeste",
          "3" ~ "Sudeste",
          "4" ~ "Sul",
          "5" ~ "Centro-Oeste"
        )
      )
    
    # states (depend on UF as well)
    df <- df %>%
      dplyr::mutate(
        sigla_uf = dplyr::case_match(
          UF,
          11 ~ "RO",
          12 ~ "AC",
          13 ~ "AM",
          14 ~ "RR",
          15 ~ "PA",
          16 ~ "AP",
          17 ~ "TO",
          21 ~ "MA",
          22 ~ "PI",
          23 ~ "CE",
          24 ~ "RN",
          25 ~ "PB",
          26 ~ "PE",
          27 ~ "AL",
          28 ~ "SE",
          29 ~ "BA",
          31 ~ "MG",
          32 ~ "ES",
          33 ~ "RJ",
          35 ~ "SP",
          41 ~ "PR",
          42 ~ "SC",
          43 ~ "RS",
          50 ~ "MS",
          51 ~ "MT",
          52 ~ "GO",
          53 ~ "DF"
        )
      )
  }
  
  # sex
  
  if ("V2007" %in% names(df)) {
    df <- df %>%
      dplyr::mutate(
        sexo = dplyr::case_match(
          V2007,
          1 ~ "Homem",
          2 ~ "Mulher"
        )
      )
  }
  
  # age groups
  
  if ("V2009" %in% names(df)) {
    df <- df %>%
      dplyr::mutate(
        faixa_idade = dplyr::case_when(
          V2009 >= 14 & V2009 <= 17 ~ "Entre 14 e 17 anos",
          V2009 >= 18 & V2009 <= 24 ~ "Entre 18 e 24 anos",
          V2009 >= 25 & V2009 <= 29 ~ "Entre 25 e 29 anos",
          V2009 >= 30 & V2009 <= 39 ~ "Entre 30 e 39 anos",
          V2009 >= 40 & V2009 <= 49 ~ "Entre 40 e 49 anos",
          V2009 >= 50 & V2009 <= 59 ~ "Entre 50 e 59 anos",
          V2009 >= 60 ~ "60 anos ou mais"
        )
      )
  }
  
  # education levels
  
  if ("VD3004" %in% names(df)) {
    df <- df %>%
      dplyr::mutate(
        faixa_educ = dplyr::case_match(
          VD3004,
          1 ~ "Sem instru\u00e7\u00e3o",
          2 ~ "1 a 7 anos de estudo",
          3 ~ "8 a 11 anos de estudo",
          4:6 ~ "9 a 14 anos de estudo",
          7 ~ "15 ou mais anos de estudo"
        )
      )
  }
  
  # Labor Market definitions taken from:
  # https://github.com/datazoompuc/datazoom_labour_amazon/blob/main/Labour_Market/code/_definicoes_pnadcontinua_trimestral.do
  
  # habitual income from all occupations
  
  if (all(c("VD4019", "Habitual") %in% names(df))) {
    df <- df %>%
      dplyr::mutate(
        rendimento_habitual = VD4019,
        rendimento_habitual_real = VD4019 * Habitual
      )
  }
  
  # occupied status
  
  if ("VD4002" %in% names(df)) {
    df <- df %>%
      dplyr::mutate(
        ocupado = ifelse(VD4002 == 1, 1, 0),
        desocupado = ifelse(VD4002 == 2, 1, 0)
      )
  }
  
  # formal vs. informal
  # depends on derived columns ocupado/desocupado, so guard on both source and derived
  
  if (all(c("ocupado", "VD4009", "VD4012") %in% names(df))) {
    df <- df %>%
      dplyr::mutate(
        formal = dplyr::case_when(
          ocupado == 1 & VD4009 %in% c(1, 3, 5, 7) ~ 1,
          ocupado == 1 & VD4009 == 9 & VD4012 == 1 ~ 1,
          .default = 0
        ),
        informal = dplyr::case_when(
          ocupado == 1 & VD4009 %in% c(2, 4, 6, 10) ~ 1,
          ocupado == 1 & VD4009 == 9 & VD4012 == 2 ~ 1,
          .default = 0
        )
      )
  }
  
  # public or private sector
  
  if ("V4012" %in% names(df)) {
    df <- df %>%
      dplyr::mutate(
        publico = ifelse(V4012 %in% c(2, 4), 1, 0),
        privado = ifelse(V4012 %in% c(1, 3, 5, 6, 7), 1, 0)
      )
  }
  
  # labor force
  
  if ("VD4001" %in% names(df)) {
    df <- df %>%
      dplyr::mutate(
        fora_forca_trab = ifelse(VD4001 == 2, 1, 0),
        forca_trab = ifelse(VD4001 == 1, 1, 0)
      )
  }
  
  # active population
  
  if (all(c("V2009", "ocupado", "desocupado") %in% names(df))) {
    df <- df %>%
      dplyr::mutate(
        pia = ifelse(V2009 >= 14, 1, 0),
        idade_de_trabalhar = ifelse(V2009 >= 15 & V2009 <= 64, 1, 0),
        pea = ocupado + desocupado
      )
  }
  
  # unemployed
  
  if (all(c("forca_trab", "desocupado") %in% names(df))) {
    df <- df %>%
      dplyr::mutate(
        desempregado = forca_trab * desocupado
      )
  }
  
  if ("VD4005" %in% names(df)) {
    df <- df %>%
      dplyr::mutate(
        desalentado = ifelse(VD4005 == 1, 1, 0)
      )
  }
  
  # neet
  
  if (all(c("desocupado", "forca_trab", "fora_forca_trab", "V3002") %in% names(df))) {
    df <- df %>%
      dplyr::mutate(
        nem_nem = dplyr::case_when(
          desocupado == 1 & forca_trab == 1 & V3002 == 2 &
            (!"V4074"  %in% names(df) | V4074  != 6  | is.na(V4074)) &
            (!"V4074A" %in% names(df) | V4074A != 8  | is.na(V4074A)) ~ 1,
          fora_forca_trab == 1 & V3002 == 2 &
            (!"V4074"  %in% names(df) | V4074  != 6  | is.na(V4074)) &
            (!"V4074A" %in% names(df) | V4074A != 8  | is.na(V4074A)) ~ 1,
          .default = 0
        )
      )
  }
  
  # positions in occupation
  
  if (all(c("VD4009", "VD4012", "V4022") %in% names(df))) {
    df <- df %>%
      dplyr::mutate(
        empregado_sc = ifelse(VD4009 %in% c(2, 4, 6, 10), 1, 0),
        empregado_cc = ifelse(VD4009 %in% c(1, 3, 5), 1, 0),
        conta_propria = ifelse(VD4009 == 9, 1, 0),
        conta_propria_contrib = ifelse(VD4009 == 9 & VD4012 == 1, 1, 0),
        conta_propria_nao_contrib = ifelse(VD4009 == 9 & VD4012 == 2, 1, 0),
        empregador = ifelse(VD4009 == 8, 1, 0),
        militar_estatutario = ifelse(VD4009 == 7, 1, 0),
        home_office = ifelse(V4022 %in% c(4, 5), 1, 0)
      )
  }
  
  # translating sector codes
  
  if ("V4013" %in% names(df)) {
    df <- df %>%
      dplyr::mutate(
        cnae_2dig = substr(V4013, 1, 2),
        cnae_2dig = dplyr::case_match(
          cnae_2dig,
          "00" ~ "Outros",
          "01" ~ "Agricultura",
          "02" ~ "Extra\u00e7\u00e3o florestal",
          "03" ~ "Pesca, ca\u00e7a e aquicultura",
          "05" ~ "Extra\u00e7\u00e3o mineral e de carv\u00e3o, petr\u00f3leo e g\u00e1s",
          "06" ~ "Extra\u00e7\u00e3o mineral e de carv\u00e3o, petr\u00f3leo e g\u00e1s",
          "07" ~ "Extra\u00e7\u00e3o mineral e de carv\u00e3o, petr\u00f3leo e g\u00e1s",
          "08" ~ "Extra\u00e7\u00e3o mineral e de carv\u00e3o, petr\u00f3leo e g\u00e1s",
          "09" ~ "Extra\u00e7\u00e3o mineral e de carv\u00e3o, petr\u00f3leo e g\u00e1s",
          "10" ~ "Alimentos, bebidas e fumo",
          "11" ~ "Alimentos, bebidas e fumo",
          "12" ~ "Pecu\u00e1ria e cria\u00e7\u00e3o de animais",
          "13" ~ "T\u00eaxtil, vestu\u00e1rio, couro e cal\u00e7ados",
          "14" ~ "Pecu\u00e1ria e cria\u00e7\u00e3o de animais",
          "15" ~ "Pesca, ca\u00e7a e aquicultura",
          "16" ~ "Madeira, celulose e papel",
          "17" ~ "Madeira, celulose e papel",
          "18" ~ "Madeira, celulose e papel",
          "19" ~ "Qu\u00edmicos, farmac\u00eauticos, borracha e pl\u00e1stico",
          "20" ~ "Qu\u00edmicos, farmac\u00eauticos, borracha e pl\u00e1stico",
          "21" ~ "Qu\u00edmicos, farmac\u00eauticos, borracha e pl\u00e1stico",
          "22" ~ "Qu\u00edmicos, farmac\u00eauticos, borracha e pl\u00e1stico",
          "23" ~ "Produtos de metal, minerais n\u00e3o-met\u00e1licos e metalurgia",
          "24" ~ "Produtos de metal, minerais n\u00e3o-met\u00e1licos e metalurgia",
          "25" ~ "Produtos de metal, minerais n\u00e3o-met\u00e1licos e metalurgia",
          "26" ~ "Servi\u00e7os jur\u00eddicos",
          "27" ~ "Eletr\u00f4nicos, m\u00e1quinas e equipamentos",
          "28" ~ "Eletr\u00f4nicos, m\u00e1quinas e equipamentos",
          "29" ~ "Autom\u00f3veis e equipamentos de transporte",
          "30" ~ "Autom\u00f3veis e equipamentos de transporte",
          "31" ~ "M\u00f3veis",
          "32" ~ "Outros",
          "33" ~ "Eletr\u00f4nicos, m\u00e1quinas e equipamentos",
          "34" ~ "Servi\u00e7os jur\u00eddicos",
          "35" ~ "Eletr\u00f4nicos, m\u00e1quinas e equipamentos",
          "36" ~ "Eletr\u00f4nicos, m\u00e1quinas e equipamentos",
          "37" ~ "Eletr\u00f4nicos, m\u00e1quinas e equipamentos",
          "38" ~ "Eletr\u00f4nicos, m\u00e1quinas e equipamentos",
          "39" ~ "Eletr\u00f4nicos, m\u00e1quinas e equipamentos",
          "41" ~ "Constru\u00e7\u00e3o",
          "42" ~ "Constru\u00e7\u00e3o",
          "43" ~ "Constru\u00e7\u00e3o",
          "45" ~ "Com\u00e9rcio",
          "48" ~ "Com\u00e9rcio",
          "49" ~ "Transporte e correio",
          "50" ~ "Transporte e correio",
          "51" ~ "Transporte e correio",
          "52" ~ "Transporte e correio",
          "53" ~ "Transporte e correio",
          "55" ~ "Estadia e turismo",
          "56" ~ "Servi\u00e7os de alimenta\u00e7\u00e3o",
          "58" ~ "Servi\u00e7os de informa\u00e7\u00e3o e comunica\u00e7\u00e3o",
          "59" ~ "Servi\u00e7os de informa\u00e7\u00e3o e comunica\u00e7\u00e3o",
          "60" ~ "Servi\u00e7os de informa\u00e7\u00e3o e comunica\u00e7\u00e3o",
          "61" ~ "Servi\u00e7os de informa\u00e7\u00e3o e comunica\u00e7\u00e3o",
          "62" ~ "Servi\u00e7os de informa\u00e7\u00e3o e comunica\u00e7\u00e3o",
          "63" ~ "Servi\u00e7os de informa\u00e7\u00e3o e comunica\u00e7\u00e3o",
          "64" ~ "Servi\u00e7os financeiros e de seguros",
          "65" ~ "Servi\u00e7os financeiros e de seguros",
          "66" ~ "Servi\u00e7os financeiros e de seguros",
          "68" ~ "Atividades profissionais, cient\u00edficas e t\u00e9cnicas",
          "69" ~ "Atividades profissionais, cient\u00edficas e t\u00e9cnicas",
          "70" ~ "Atividades profissionais, cient\u00edficas e t\u00e9cnicas",
          "71" ~ "Atividades profissionais, cient\u00edficas e t\u00e9cnicas",
          "72" ~ "Atividades profissionais, cient\u00edficas e t\u00e9cnicas",
          "73" ~ "Atividades profissionais, cient\u00edficas e t\u00e9cnicas",
          "74" ~ "Atividades profissionais, cient\u00edficas e t\u00e9cnicas",
          "75" ~ "Atividades profissionais, cient\u00edficas e t\u00e9cnicas",
          "78" ~ "Terceiriza\u00e7\u00e3o de m\u00e3o-de-obra",
          "79" ~ "Estadia e turismo",
          "80" ~ "Seguran\u00e7a e edif\u00edcios",
          "81" ~ "Seguran\u00e7a e edif\u00edcios",
          "82" ~ "Seguran\u00e7a e edif\u00edcios",
          "84" ~ "Administra\u00e7\u00e3o p\u00fablica, defesa e seguridade social",
          "85" ~ "Educa\u00e7\u00e3o",
          "86" ~ "Sa\u00fade e assist\u00eancia social",
          "87" ~ "Sa\u00fade e assist\u00eancia social",
          "88" ~ "Sa\u00fade e assist\u00eancia social",
          "90" ~ "Artes, cultura, esportes e recrea\u00e7\u00e3o",
          "91" ~ "Artes, cultura, esportes e recrea\u00e7\u00e3o",
          "92" ~ "Artes, cultura, esportes e recrea\u00e7\u00e3o",
          "93" ~ "Artes, cultura, esportes e recrea\u00e7\u00e3o",
          "94" ~ "Organiza\u00e7\u00f5es religiosas, sindicais e patronais",
          "95" ~ "Servi\u00e7os de informa\u00e7\u00e3o e comunica\u00e7\u00e3o",
          "96" ~ "Servi\u00e7os pessoais (cabelereiros, lavanderias, etc.)",
          "97" ~ "Servi\u00e7os dom\u00e9sticos",
          "99" ~ "Outros"
        ),
        cnae_2dig = dplyr::case_match(
          V4013,
          as.numeric(c(paste0(0, 1201:1209), paste0(0, 1402:1409), "01999")) ~ "Pecu\u00e1ria e cria\u00e7\u00e3o de animais",
          .default = cnae_2dig
        )
      )
  }
  
  # translating occupation codes
  
  if ("V4010" %in% names(df)) {
    df <- df %>%
      dplyr::mutate(
        cod_2dig = substr(V4010, 1, 2),
        cod_2dig = dplyr::case_match(
          cod_2dig,
          "01" ~ "Policiais, bombeiros e for\u00e7as armadas",
          "02" ~ "Policiais, bombeiros e for\u00e7as armadas",
          "04" ~ "Policiais, bombeiros e for\u00e7as armadas",
          "05" ~ "Policiais, bombeiros e for\u00e7as armadas",
          "11" ~ "Trabalhadores no governo",
          "12" ~ "Dirigentes e gerentes",
          "13" ~ "Dirigentes e gerentes",
          "14" ~ "Dirigentes e gerentes",
          "21" ~ "Cientistas e engenheiros",
          "22" ~ "Profissionais da sa\u00fade",
          "23" ~ "Profissionais do ensino",
          "24" ~ "Administradores e especialista em gest\u00e3o",
          "25" ~ "Servi\u00e7os de TI e comunica\u00e7\u00e3o",
          "26" ~ "Servi\u00e7os jur\u00eddicos",
          "31" ~ "Cientistas e engenheiros",
          "32" ~ "Profissionais da sa\u00fade",
          "33" ~ "Servi\u00e7os financeiros e administrativos",
          "34" ~ "Servi\u00e7os jur\u00eddicos",
          "35" ~ "Servi\u00e7os de TI e comunica\u00e7\u00e3o",
          "41" ~ "Escritur\u00e1rios",
          "42" ~ "Atendimento direto ao p\u00fablico",
          "43" ~ "Apoio administrativo",
          "44" ~ "Apoio administrativo",
          "51" ~ "Servi\u00e7os e cuidados pessoais",
          "52" ~ "Vendedores",
          "53" ~ "Servi\u00e7os e cuidados pessoais",
          "54" ~ "Profissionais de seguran\u00e7a",
          "61" ~ "Pecuaristas e criadores de animais",
          "62" ~ "Pecuaristas e criadores de animais",
          "71" ~ "Oper\u00e1rios da constru\u00e7\u00e3o, metalurgia e ind\u00fastria",
          "72" ~ "Oper\u00e1rios da constru\u00e7\u00e3o, metalurgia e ind\u00fastria",
          "73" ~ "Artes\u00f5es e artes gr\u00e1ficas",
          "74" ~ "T\u00e9cnicos de eletricidade e eletr\u00f4nica",
          "75" ~ "Oper\u00e1rios de processamento e instala\u00e7\u00f5es",
          "81" ~ "Oper\u00e1rios de processamento e instala\u00e7\u00f5es",
          "82" ~ "Montadores e condutores de ve\u00edculos",
          "83" ~ "Montadores e condutores de ve\u00edculos",
          "91" ~ "Dom\u00e9sticos",
          "92" ~ "Pecuaristas e criadores de animais",
          "93" ~ "Oper\u00e1rios da constru\u00e7\u00e3o, metalurgia e ind\u00fastria",
          "94" ~ "Profissionais em alimenta\u00e7\u00e3o",
          "95" ~ "Ambulantes",
          "96" ~ "Coletores de lixo"
        ),
        cod_2dig = ifelse(V4010 == 9215, "Extrativistas florestais", cod_2dig)
      )
  }
  
  return(df)
}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

library(datazoom.social)


## ----eval=FALSE---------------------------------------------------------------
# panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "basic")
# 

## ----eval=FALSE---------------------------------------------------------------
# # Stage 1: Exact matching with donated birth dates
# panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced_1")
# 
# # Stage 2: Relaxed matching constraints
# panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced_2")
# 
# # Stage 3: Fuzzy matching using Graph Theory (Recommended)
# panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced_3")
# 

# Create an attrition table for a PNADc panel file
#
# @keywords internal
calculate_panel_attrition <- function(data, panel) {
  
  # binding globals
  V1016 <- individual_id <- present <- NULL
  
  # 1. Standardize ID column based on panel type
  id_col <- switch(panel,
                   "basic"      = "id_ind",
                   "advanced"   = "id_rs",
                   "households" = "id_dom",
                   stop("Invalid panel type. Use 'basic', 'advanced', or 'households'."))
  
  message(paste0(stringr::str_to_title(panel), " panel attrition calculated."))
  
  # 2. Preparation: Filter for those present in Wave 1 and rename ID
  df_prepared <- data %>%
    dplyr::mutate(V1016 = as.integer(V1016)) %>%
    dplyr::rename(individual_id = !!id_col)
  
  ids_w1 <- df_prepared %>%
    dplyr::filter(V1016 == 1) %>%
    dplyr::pull(individual_id) %>%
    unique()
  
  n_w1 <- length(ids_w1)
  
  # 3. Create a wide presence matrix (1 if present, 0 if absent)
  # This makes logical comparisons across waves much faster
  presence_matrix <- df_prepared %>%
    dplyr::filter(individual_id %in% ids_w1) %>%
    dplyr::select(individual_id, V1016) %>%
    dplyr::mutate(present = 1) %>%
    tidyr::pivot_wider(names_from = V1016, 
                       values_from = present, 
                       names_prefix = "w", 
                       values_fill = 0)
  
  # 4. Initialize the results storage
  results <- data.frame(
    wave_step               = character(),
    n_missing_uncond        = numeric(),
    n_found_uncond          = numeric(),
    pct_found_uncond        = numeric(),
    n_missing_cond          = numeric(),
    n_found_cond            = numeric(),
    pct_found_cond_w1       = numeric(),
    pct_found_cond_prev     = numeric(),
    stringsAsFactors        = FALSE
  )
  
  # 5. Calculate metrics for each transition (1->2, 2->3, 3->4, 4->5)
  # For conditional, we track the 'survivors' who were in ALL previous waves
  current_cond_ids <- ids_w1
  
  for (i in 1:4) {
    prev_w <- paste0("w", i)
    next_w <- paste0("w", i + 1)
    
    # --- Unconditional Logic ---
    # Who was in Wave i?
    ids_in_prev <- presence_matrix$individual_id[presence_matrix[[prev_w]] == 1]
    # Out of those, who is in Wave i + 1?
    found_uncond <- presence_matrix %>%
      dplyr::filter(!!rlang::sym(prev_w) == 1, !!rlang::sym(next_w) == 1) %>%
      nrow()
    
    # --- Conditional Logic ---
    # Who was in ALL waves from 1 to i? (stored in current_cond_ids)
    # Out of those, who is also in Wave i + 1?
    found_cond_df <- presence_matrix %>%
      dplyr::filter(individual_id %in% current_cond_ids, !!rlang::sym(next_w) == 1)
    
    n_found_cond <- nrow(found_cond_df)
    n_missing_cond <- length(current_cond_ids) - n_found_cond
    
    # Update denominator for next conditional step
    prev_cond_total <- length(current_cond_ids)
    current_cond_ids <- found_cond_df$individual_id
    
    # --- Assemble Row ---
    results[i, ] <- list(
      wave_step           = paste("Wave", i, "to", i + 1),
      n_missing_uncond    = length(ids_in_prev) - found_uncond,
      n_found_uncond      = found_uncond,
      pct_found_uncond    = (found_uncond / n_w1) * 100,
      n_missing_cond      = n_missing_cond,
      n_found_cond        = n_found_cond,
      pct_found_cond_w1   = (n_found_cond / n_w1) * 100,
      pct_found_cond_prev = (n_found_cond / prev_cond_total) * 100
    )
  }
  
  return(results)
}

#' Build PNADc Panel
#'
#' This function builds a panel dataset from PNADC data, identifying households and individuals.
#'
#' @param dat Data frame with PNADC data, sorted into a single panel.
#' @param panel A \code{character} with the type of panel identification. Use "none" for no paneling, "basic" for basic paneling, "advanced_1" for advanced stage 1 paneling, "advanced_2" for advanced stage 2 paneling, and "advanced_3" for the fuzzy-matching stage 3 paneling.
#'
#' @return A modified dataset with added identifiers for household (\code{id_dom}) and individual (\code{id_ind}, and progressively \code{id_rs1}, \code{id_rs2}, or \code{id_rs3}) based on the chosen panel algorithm.
#'
#' @examplesIf interactive()
#' # Example usage:
#' 
#' panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced_3")
#'
#' @export
build_pnadc_panel <- function(dat, panel) {
  ###########################
  ## Bind Global Variables ##
  ###########################
  
  UPA <- V1008 <- V1014 <- id_dom <- V20082 <- V20081 <- V2008 <- V2007 <- NULL
  Ano <- Trimestre <- id_ind <- num_appearances <- V2003 <- V2009 <- NULL
  q_count_ind <- NULL
  birth_day <- birth_month <- birth_year <- NULL
  id_rs1 <- id_rs2 <- id_rs3 <- num_appearances_rs1 <- num_appearances_rs2 <- NULL
  q_count_rs1 <- q_count_rs2 <- q_count_rs3 <- NULL
  is_candidate <- row_id <- row_id.A <- row_id.B <- NULL
  Ano.A <- Ano.B <- Trimestre.A <- Trimestre.B <- NULL
  V2007.A <- V2007.B <- birth_day.A <- birth_day.B <- NULL
  birth_month.A <- birth_month.B <- V2009.A <- V2009.B <- NULL
  id_rs3_fuzzy <- cluster_id <- NULL
  
  ###################
  ## Cleaning Data ## 
  ###################
  
  dat <- dat %>%
    # Convert dates and ages to numeric
    dplyr::mutate(
      V2008  = as.numeric(V2008),
      V20081 = as.numeric(V20081),
      V20082 = as.numeric(V20082),
      V2009  = as.numeric(V2009),
      Ano    = as.numeric(Ano)
    ) %>%
    # Identify the error codes (99/9999) and replace them with NA
    dplyr::mutate(
      V2008  = dplyr::if_else(V2008 == 99, NA_real_, V2008),
      V20081 = dplyr::if_else(V20081 == 99, NA_real_, V20081),
      V20082 = dplyr::if_else(V20082 == 9999, NA_real_, V20082)
    )
  
  #############################
  ## Define Basic Parameters ## 
  #############################
  
  # Check if the panel type is 'none'; if so, return the original raw data
  if (panel == "none") {
    return(dat)
  }
  
  ##########################
  ## Basic Identification ##
  ##########################
  
  # If the panel type is not 'none', perform the basic identification steps
  if (panel != "none") {
    # Household identifier combines UPA, V1008, and V1014, creating a unique number for every combination of those variables using cur_group_id
    dat <- dat %>%
      dplyr::mutate(
        id_dom = dplyr::cur_group_id(),
        .by = c("UPA", "V1008", "V1014")
      )
    
    # Individual identifier combines the household ID, sex (V2007), and date of birth (V20082, V20081, V2008), creating a unique number for every combination
    dat <- dat %>%
      dplyr::mutate(
        id_ind = dplyr::cur_group_id(),
        .by = c("id_dom", "V20082", "V20081", "V2008", "V2007")
      )
    
    # Twin removal
    dat <- dat %>%
      dplyr::add_count(id_ind, Ano, Trimestre, name = "num_appearances") %>% # Counts the number of times that each id_ind appears in the same quarter
      dplyr::mutate(
        id_ind = dplyr::case_when(
          num_appearances != 1 ~ NA_real_,
          .default = id_ind
        ))
    
    # Treat missing values
    dat <- dat %>% dplyr::mutate(
      id_ind = dplyr::case_when(
        V2008 == NA | V20081 == NA | V20082 == NA ~ NA_real_,
        .default = id_ind
      )
    )
  }
  
  #############################
  ## Advanced Identification ##
  #############################
  
  if (panel %in% c("advanced_1", "advanced_2", "advanced_3")) {
    
    # Call the internal donation function to populate birth_day, birth_month, and birth_year
    dat <- donate_birth_dates(dat)
    
    ## Stage 1:
    m <- max(dat$id_ind, na.rm = TRUE) # Avoid overlap between ID numbers
    
    dat <- dat %>%
      dplyr::mutate(
        id_rs1 = dplyr::cur_group_id() + m,
        .by = c("id_dom", "birth_year", "birth_month", "birth_day", "V2007")
      ) %>%
      # Twin removal for Stage 1
      dplyr::add_count(id_rs1, Ano, Trimestre, name = "num_appearances_rs1") %>%
      dplyr::mutate(
        id_rs1 = dplyr::case_when(
          num_appearances_rs1 != 1 ~ NA_real_,
          is.na(birth_year) | is.na(birth_month) | is.na(birth_day) ~ NA_real_,
          .default = id_rs1
        )
      )
    
    # Stage 1 evaluation and fallback
    dat <- dat %>%
      dplyr::mutate(
        q_count_ind = dplyr::n_distinct(interaction(Ano, Trimestre)), 
        .by = "id_ind"
      ) %>%
      dplyr::mutate(
        q_count_rs1 = dplyr::n_distinct(interaction(Ano, Trimestre)), 
        .by = "id_rs1"
      ) %>%
      dplyr::mutate(
        # id_rs1 falls back to id_ind if the basic method performed better or perfectly
        id_rs1 = dplyr::case_when(
          q_count_ind == 5 ~ id_ind,
          q_count_rs1 > q_count_ind & q_count_rs1 <= 5 ~ id_rs1,
          TRUE ~ dplyr::coalesce(id_ind, id_rs1)
        ),
        # Update q_count_rs1 to reflect the merged reality for the potential next stage
        q_count_rs1 = dplyr::case_when(
          q_count_ind == 5 ~ q_count_ind,
          q_count_rs1 > q_count_ind & q_count_rs1 <= 5 ~ q_count_rs1,
          TRUE ~ dplyr::coalesce(q_count_ind, q_count_rs1)
        )
      )
    
    ## Stage 2:
    if (panel %in% c("advanced_2", "advanced_3")) {
      m2 <- max(dat$id_rs1, na.rm = TRUE) # Avoid overlap with Stage 1 IDs
      
      dat <- dat %>%
        dplyr::mutate(
          id_rs2 = dplyr::cur_group_id() + m2,
          .by = c("id_dom", "birth_month", "birth_day", "V2003")
        ) %>%
        # Twin removal for Stage 2
        dplyr::add_count(id_rs2, Ano, Trimestre, name = "num_appearances_rs2") %>%
        dplyr::mutate(
          id_rs2 = dplyr::case_when(
            num_appearances_rs2 != 1 ~ NA_real_,
            is.na(birth_month) | is.na(birth_day) ~ NA_real_,
            .default = id_rs2
          )
        )
      
      # Stage 2 evaluation and fallback
      dat <- dat %>%
        dplyr::mutate(
          q_count_rs2 = dplyr::n_distinct(interaction(Ano, Trimestre)), 
          .by = "id_rs2"
        ) %>%
        dplyr::mutate(
          # id_rs2 falls back to the already-optimized id_rs1
          id_rs2 = dplyr::case_when(
            q_count_rs1 == 5 ~ id_rs1, 
            q_count_rs2 > q_count_rs1 & q_count_rs2 <= 5 ~ id_rs2,
            TRUE ~ dplyr::coalesce(id_rs1, id_rs2)
          ),
          q_count_rs2 = dplyr::case_when(
            q_count_rs1 == 5 ~ q_count_rs1,
            q_count_rs2 > q_count_rs1 & q_count_rs2 <= 5 ~ q_count_rs2,
            TRUE ~ dplyr::coalesce(q_count_rs1, q_count_rs2)
          )
        )
    }
    
    ## Stage 3 (Fuzzy Matching):
    if (panel == "advanced_3") {
      if (!requireNamespace("igraph", quietly = TRUE)) {
        stop("The 'igraph' package is required for the 'advanced_3' panel algorithm. Please install it using install.packages('igraph').")
      }
      
      # 1. Target Candidates (Less than 5 successful matches in id_rs2)
      dat <- dat %>%
        dplyr::mutate(
          is_candidate = dplyr::coalesce(q_count_rs2 < 5, TRUE),
          row_id = dplyr::row_number()
        )
      
      candidates <- dat %>% dplyr::filter(is_candidate)
      
      # 2. Build the Nest (Self-join within household)
      nest <- candidates %>%
        dplyr::select(row_id, id_dom, V2007, birth_day, birth_month, V2009, Ano, Trimestre) %>%
        dplyr::inner_join(
          candidates %>% dplyr::select(row_id, id_dom, V2007, birth_day, birth_month, V2009, Ano, Trimestre),
          by = "id_dom",
          suffix = c(".A", ".B"),
          relationship = "many-to-many"
        ) %>%
        # Apply strict fuzzy evaluation constraints inside the nest
        dplyr::filter(
          row_id.A != row_id.B,
          interaction(Ano.A, Trimestre.A) != interaction(Ano.B, Trimestre.B),
          V2007.A == V2007.B,
          abs(birth_day.A - birth_day.B) <= 4,
          abs(birth_month.A - birth_month.B) <= 2,
          abs(V2009.A - V2009.B) <= dplyr::if_else(V2009.A < 25, 2, exp(V2009.A / 30))
        )
      
      # 3. Apply Uniqueness Tie-Breaker
      valid_matches <- nest %>%
        dplyr::group_by(row_id.A, Ano.B, Trimestre.B) %>%
        dplyr::filter(dplyr::n() == 1) %>% 
        dplyr::ungroup()
      
      # 4. Generate Graph & Component IDs
      if (nrow(valid_matches) > 0) {
        
        edges_char <- cbind(
          as.character(valid_matches$row_id.A), 
          as.character(valid_matches$row_id.B)
        )
        
        g <- igraph::graph_from_edgelist(edges_char, directed = FALSE)
        comps <- igraph::components(g)$membership
        
        cluster_map <- data.frame(
          row_id = as.integer(names(comps)),
          cluster_id = as.integer(comps)
        )
        
        m3 <- max(dat$id_rs2, na.rm = TRUE)
        cluster_map$id_rs3_fuzzy <- cluster_map$cluster_id + m3
        
        dat <- dat %>%
          dplyr::left_join(cluster_map, by = "row_id") %>%
          dplyr::mutate(
            id_rs3 = dplyr::case_when(
              !is_candidate ~ id_rs2,
              !is.na(id_rs3_fuzzy) ~ id_rs3_fuzzy,
              TRUE ~ id_rs2
            )
          )
      } else {
        dat <- dat %>% dplyr::mutate(id_rs3 = id_rs2)
      }
      
      # 5. Evaluate and Fallback
      dat <- dat %>%
        dplyr::mutate(
          q_count_rs3 = dplyr::n_distinct(interaction(Ano, Trimestre)), 
          .by = "id_rs3"
        ) %>%
        dplyr::mutate(
          # id_rs3 falls back to id_rs2 if rs2 performed better
          id_rs3 = dplyr::case_when(
            q_count_rs2 == 5 ~ id_rs2,
            q_count_rs3 > q_count_rs2 & q_count_rs3 <= 5 ~ id_rs3,
            TRUE ~ dplyr::coalesce(id_rs2, id_rs3)
          ),
          q_count_rs3 = dplyr::case_when(
            q_count_rs2 == 5 ~ q_count_rs2,
            q_count_rs3 > q_count_rs2 & q_count_rs3 <= 5 ~ q_count_rs3,
            TRUE ~ dplyr::coalesce(q_count_rs2, q_count_rs3)
          )
        )
      
      # Discard the nest and related tracking variables from the environment
      rm(candidates, nest, valid_matches)
    }
    
    # Cleanup auxiliary variables mapped during the advanced stages (KEEPING id_rs1 & id_rs2 & id_rs3)
    cols_to_remove <- c("num_appearances_rs1", "q_count_rs1", "q_count_ind")
    if (panel %in% c("advanced_2", "advanced_3")) {
      cols_to_remove <- c(cols_to_remove, "num_appearances_rs2", "q_count_rs2")
    }
    if (panel == "advanced_3") {
      cols_to_remove <- c(cols_to_remove, "is_candidate", "row_id", "id_rs3_fuzzy", "q_count_rs3")
    }
    dat <- dat %>% dplyr::select(-dplyr::any_of(cols_to_remove))
  }
  
  ##########################
  ## Pasting Panel Number ##
  ##########################
  
  # To avoid overlap when binding more than one panel (all IDs are just counts from 1, ..., N)
  # The ifelse function guards against as.hexmode(NA) which returns the string "NA" instead of a true NA
  
  # Basic panel
  if (panel != "none") {
    dat$id_ind <- ifelse(
      is.na(dat$id_ind),
      NA_character_,
      paste0(as.hexmode(dat$V1014), as.hexmode(dat$id_ind))
    )
  }
  
  # Advanced panel 1
  if (panel %in% c("advanced_1", "advanced_2", "advanced_3")) {
    dat$id_rs1 <- ifelse(
      is.na(dat$id_rs1),
      NA_character_,
      paste0(as.hexmode(dat$V1014), as.hexmode(dat$id_rs1))
    )
  }
  
  # Advanced panel 2
  if (panel %in% c("advanced_2", "advanced_3")) {
    dat$id_rs2 <- ifelse(
      is.na(dat$id_rs2),
      NA_character_,
      paste0(as.hexmode(dat$V1014), as.hexmode(dat$id_rs2))
    )
  }
  
  # Advanced panel 3
  if (panel == "advanced_3") {
    dat$id_rs3 <- ifelse(
      is.na(dat$id_rs3),
      NA_character_,
      paste0(as.hexmode(dat$V1014), as.hexmode(dat$id_rs3))
    )
  }
  
  #################
  ## Return Data ##
  #################
  
  # Return the modified dataset
  return(dat)
}

#' Simulated PNAD sample dataset
#'
#' A small simulated dataset inspired by microdata from the Brazilian
#' Continuous National Household Sample Survey (PNAD Contínua), included for
#' examples, tests, and documentation in the `datazoom.social` package.
#'
#' This dataset does not contain real PNAD observations. It was created only
#' for demonstration purposes and includes a small subset of variables from the
#' original files distributed by IBGE. Its reduced size makes package examples
#' faster and lighter, while preserving a structure similar to that of the
#' original survey data.
#'
#' @format A `data.table` and `data.frame` with 31 rows and 23 variables:
#' \describe{
#'   \item{V1}{Record identifier.}
#'   \item{Ano}{Survey year.}
#'   \item{Trimestre}{Survey quarter.}
#'   \item{UF}{Federative unit code.}
#'   \item{UPA}{Primary sampling unit identifier.}
#'   \item{V1008}{Household serial identifier.}
#'   \item{V1014}{Number of household members.}
#'   \item{V1016}{Household interview status or type code.}
#'   \item{V20082}{Year of birth.}
#'   \item{V20081}{Month of birth.}
#'   \item{V2008}{Day of birth or age-related auxiliary code, as provided in the simulated data.}
#'   \item{V2007}{Sex code.}
#'   \item{V2009}{Age in years.}
#'   \item{VD3004}{Educational attainment code.}
#'   \item{VD4001}{Labor force status code.}
#'   \item{VD4002}{Employment status code.}
#'   \item{VD4005}{Employment position or job category code.}
#'   \item{VD4009}{Usual hours worked category or related labor variable code.}
#'   \item{VD4019}{Monthly labor income.}
#'   \item{V4010}{Main job identifier or occupation-related code.}
#'   \item{V4012}{Economic activity or occupation grouping code.}
#'   \item{V4013}{Time in job or age-related auxiliary labor code.}
#'   \item{V4022}{Household or person weight, as represented in the simulated data.}
#' }
#'
#' @details
#' The purpose of `pnad_sample` is to provide a lightweight object that mimics
#' part of the structure of PNAD Contínua microdata, allowing users to run
#' examples without downloading or processing the full original files.
#'
#' Variable names follow the naming convention used in the original survey
#' microdata, but the values in this dataset are simulated and should not be
#' used for substantive empirical analysis.
#'
#' @source Inspired by the structure of PNAD Contínua microdata produced by the
#' Brazilian Institute of Geography and Statistics (IBGE).
#' \url{https://www.ibge.gov.br}
"pnad_sample"

#' Donate Birth Dates for PNADC
#'
#' This internal function reproduces Rafael Osorio's birth date donation method. 
#' It estimates and imputes missing birth dates (day, month, and year) by matching 
#' individuals with donors from different interviews within the same household based 
#' on sex, acceptable household condition changes, and estimated age.
#'
#' @param dat A data frame with PNADC data to be processed.
#'
#' @return A modified dataset with donated birth dates replacing missing ones. 
#' The final dataset includes updated \code{birth_day}, \code{birth_month}, and 
#' \code{birth_year} variables.
#' 
#' @keywords internal
#' @noRd
donate_birth_dates <- function(dat) {
  
  ###########################
  ## Bind Global Variables ##
  ###########################
  
  UPA <- V1008 <- V1014 <- id_dom <- V2008 <- V20081 <- V20082 <- NULL
  Ano <- V2009 <- V2005 <- V2007 <- V1016 <- V1016.x <- V1016.y <- NULL
  year_missing <- year_estimated <- summarised_condition <- diff <- NULL
  donor_day <- donor_month <- donor_year <- NULL
  
  ##########################################
  ## Pre-processing & Auxiliary Variables ##
  ##########################################
  
  prep <- dat %>%
    dplyr::mutate(
      # Create a unique household identifier
      id_dom = dplyr::cur_group_id(),
      .by = c(UPA, V1008, V1014)
    ) %>%
    dplyr::mutate(
      
      # Identify observations that are missing the birth year (those needing donations)
      year_missing = is.na(V20082),
      
      # Estimate birth year to compare with potential donors' years and choose the best candidate
      year_estimated = Ano - V2009,
      
      # Map acceptable household condition interchanges based on the methodology
      summarised_condition = dplyr::case_when(
        V2005 %in% c(1, 2, 3) ~ 1,
        V2005 %in% c(4, 5, 6) ~ 4,
        V2005 %in% c(8, 9)    ~ 8,
        TRUE ~ as.numeric(V2005)
      )
    )
  
  ###########################
  ## Define the Donor Pool ##
  ###########################
  
  donors <- prep %>%
    # Potential donors must have a known (non-missing) birth year
    dplyr::filter(!year_missing) %>%
    dplyr::select(id_dom, V1016, V2007, summarised_condition, 
                  donor_day = V2008, donor_month = V20081, donor_year = V20082)
  
  #########################################
  ## Vectorized Search for Best Donors   ##
  #########################################
  
  imputed_matches <- prep %>%
    dplyr::filter(year_missing) %>%
    # We join candidates and donors by household, sex, and condition group
    dplyr::left_join(donors, by = c("id_dom", "V2007", "summarised_condition"), 
                     relationship = "many-to-many") %>%
    # Apply Step 2.a criteria: the donor must be from a different interview, 
    # and the donor's year must be within a 3-year window of the estimated year
    dplyr::filter(
      V1016.x != V1016.y, 
      abs(donor_year - year_estimated) <= 3
    ) %>%
    # Step 2.b: Calculate the absolute difference for sorting purposes
    dplyr::mutate(diff = abs(donor_year - year_estimated)) %>%
    # Optimized selection: Arrange candidates by the closest match, then pick the first one
    dplyr::arrange(id_dom, V1016.x, V2007, summarised_condition, V2009, diff) %>%
    dplyr::distinct(id_dom, V1016.x, V2007, summarised_condition, V2009, .keep_all = TRUE)
  
  ######################
  ## Final Merge Back ##
  ######################
  
  # Combine the matches back with the original data, prioritizing original values where they exist
  final_data <- prep %>%
    dplyr::left_join(
      imputed_matches %>% 
        dplyr::select(id_dom, V1016.x, V2007, summarised_condition, V2009, 
                      donor_day, donor_month, donor_year),
      by = c("id_dom", "V1016" = "V1016.x", "V2007", "summarised_condition", "V2009")
    ) %>%
    # Step 2.c: Fallback logic using coalesce (if the original is NA, use the donor's value)
    dplyr::mutate(
      birth_day   = dplyr::coalesce(V2008, donor_day),
      birth_month = dplyr::coalesce(V20081, donor_month),
      birth_year  = dplyr::coalesce(V20082, donor_year)
    ) %>%
    # Cleanup auxiliary tracking columns
    dplyr::select(-donor_day, -donor_month, -donor_year, -year_missing, 
                  -year_estimated, -summarised_condition)
  
  #################
  ## Return Data ##
  #################
  
  # Return the modified dataset with donated birth dates
  return(final_data)
}

#' Create an attrition table for a panel file
#'
#' This function generates a summary dataframe indicating the count of missing
#' interviews for each individual and the unconditional tracking rates.
#'
#' @param data The input data frame, preferably a PNADc panel file.
#' @param panel The identification strategy: "basic", "advanced_1", "advanced_2", "advanced_3" or "households".
#'
#' @return A data frame summarizing missing interviews and the tracking rates.
cria_df_de_atrito <- function(data, panel) {
  # Binding globals
  V1016 <- individual_identifier <- disappearances <- NULL
  
  data$V1016 <- as.integer(data$V1016)
  
  # Identify which panel strategy is being calculated
  if (panel == "basic") {
    data <- data %>% dplyr::rename("individual_identifier" = "id_ind")
    print("Basic panel attrition calculated.")
  } else if (panel == "advanced_1") {
    data <- data %>% dplyr::rename("individual_identifier" = "id_rs1")
    print("Advanced Stage 1 panel attrition calculated.")
  } else if (panel == "advanced_2") {
    data <- data %>% dplyr::rename("individual_identifier" = "id_rs2")
    print("Advanced Stage 2 panel attrition calculated.")
  } else if (panel == "advanced_3") {
    data <- data %>% dplyr::rename("individual_identifier" = "id_rs3")
    print("Advanced Stage 3 (Fuzzy) panel attrition calculated.")
  } else if (panel == "households") {
    data <- data %>% dplyr::rename("individual_identifier" = "id_dom")
    print("Household panel attrition calculated.")
  }
  
  # 1. Fundamental Definitions (The Baseline - Wave 1)
  
  # N_linhas: The absolute total number of raw observations recorded in Wave 1
  N_linhas <- sum(data$V1016 == 1, na.rm = TRUE)
  
  # Identify the valid IDs present in Wave 1
  presentes_na_1a_entrevista <- data %>%
    dplyr::filter(V1016 == 1 & !is.na(individual_identifier)) %>%
    dplyr::pull(individual_identifier) %>%
    unique()
  
  # N_ids: The total number of unique and valid identifiers successfully built in Wave 1
  N_ids <- length(presentes_na_1a_entrevista)
  
  # Filter the data only for the cohort we are actively tracking
  data <- data %>%
    dplyr::filter(individual_identifier %in% presentes_na_1a_entrevista)
  
  # --- ORIGINAL STRUCTURE MAINTAINED ---
  # Generate a summary data frame mapping appearances and disappearances
  summary_data <- data %>%
    dplyr::group_by(individual_identifier) %>%
    dplyr::summarize(
      appearances = list(V1016),
      disappearances = list(setdiff(1:5, unique(V1016)))
    ) %>%
    dplyr::rowwise() %>%
    dplyr::mutate(
      missing_quarters = paste(as.character(unlist(disappearances)), collapse = " "),
      first_interview = ifelse("1" %in% unlist(disappearances), 1, 0),
      second_interview = ifelse("2" %in% unlist(disappearances), 1, 0),
      third_interview = ifelse("3" %in% unlist(disappearances), 1, 0),
      fourth_interview = ifelse("4" %in% unlist(disappearances), 1, 0),
      fifth_interview = ifelse("5" %in% unlist(disappearances), 1, 0)
    )
  
  # Create a data frame for definite attrition tracking
  atrito_definite <- data.frame(Onda = seq(1, 5), "Contagem_de_faltantes" = c(0, 0, 0, 0, 0))
  
  # Calculate the total count of missing interviews for each wave
  for (i in 5:ncol(summary_data)) {
    atrito_definite[i - 4, 2] <- sum(summary_data[, i])
  }
  
  # --- APPLICATION OF THE DATA ZOOM GUIDE FORMULAS ---
  
  # S_w: Survivors Found in Wave w
  atrito_definite$Sobreviventes_S_w <- N_ids - atrito_definite$Contagem_de_faltantes
  
  # Metric A: Unconditional Rate (ID-Based) -> (S_w / N_ids) * 100
  atrito_definite$Taxa_Incondicional_Base_ID <- (atrito_definite$Sobreviventes_S_w / N_ids) * 100
  
  # Metric B: Unconditional Rate (Line-Based) -> (S_w / N_linhas) * 100
  atrito_definite$Taxa_Incondicional_Base_Linha <- (atrito_definite$Sobreviventes_S_w / N_linhas) * 100
  
  # Export the quantity of observations to be used as weights in the final mean calculations
  atrito_definite$Peso_N_ids <- N_ids
  atrito_definite$Peso_N_linhas <- N_linhas
  
  return(atrito_definite)
}

---
title: "LOAD_PNADC"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{LOAD_PNADC}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```


The `load_pnadc` function is a wrapper for [*`get_pnadc`*](https://www.rdocumentation.org/packages/PNADcIBGE/versions/0.7.0/topics/get_pnadc) from the package `PNADcIBGE`, with added identification algorithms for panel construction. For details on the identification algorithms, see `vignette("BUILD_PNADC_PANEL")`.

***
**Panel Structure:**

The table below shows the first and last quarter (`ANOtrimestre`, e.g.
`20121` = 2012 Q1) covered by each PNADC rotating panel:

| Panel | Start | End   |
|------:|------:|------:|
| 1     | 20121 | 20124 |
| 2     | 20121 | 20141 |
| 3     | 20132 | 20152 |
| 4     | 20143 | 20163 |
| 5     | 20154 | 20174 |
| 6     | 20171 | 20191 |
| 7     | 20182 | 20202 |
| 8     | 20193 | 20213 |
| 9     | 20204 | 20224 |
| 10    | 20221 | 20241 |
| 11    | 20232 | 20252 |
| 12    | 20243 | 20263 |
| 13    | 20254 | 20274 |
| 14    | 20271 | 20291 |

***
**Usage:**

Default

```{r eval=FALSE}

load_pnadc(
  save_to = getwd(),
  years,
  quarters = 1:4,
  panel = "advanced",
  raw_data = FALSE,
  save_options = c(TRUE, TRUE),
  vars = NULL
)

```

To download PNADC data for all quarters of 2022 and 2023, with advanced identification, simply run

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022:2023
)
```

To download PNADC data for all of 2022, but only the first quarter of 2023, run

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022:2023,
  quarters = list(1:4, 1)
)
```

To download PNADC data without any variables treatment or identification (e.g., for all quarters of 2021), run

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2021,
  panel = "none",
  raw_data = TRUE
)
```

To download PNADC data, keep the quarters parquet on disk, and save panels as Parquet, run

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  save_options = c(TRUE, FALSE)
)
```

To download PNADC data and save panels as CSV but discard the intermediate quarters parquet, run

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  save_options = c(FALSE, TRUE)
)
```

To download only a specific subset of variables — for example, age (`V2009`) and habitual income (`VD4019`) — alongside the structural columns that `PNADcIBGE` always returns, run

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  vars = c("V2009", "VD4019")
)
```

> **Note:** `PNADcIBGE::get_pnadc()` always downloads a set of ~210 structural
> columns regardless of the `vars` argument. These include survey design weights
> (`V1027`, `V1028`, `V1028001`–`V1028200`, `posest`, `posest_sxi`), deflator
> variables (`Habitual`, `Efetivo`), and identifiers such as `UF`, `Estrato`,
> `V1029`, `V1033`, and `ID_DOMICILIO`. The `vars` argument adds columns
> **on top of** those; it does not restrict them. Use `vars = NULL` (the
> default) to download all available microdata columns.

If you specify `vars` and also request panel identification, any columns
required by the identification algorithm that are absent from `vars` will be
added automatically and a warning will tell you which ones were added. For
example, when using `panel = "advanced"`, the columns `V2007`, `V20082`,
`V20081`, `V2008`, and `V2003` must be present. If you omit them from `vars`,
the function adds them for you:

```{r eval=FALSE}
# Only V2009 requested, but panel = "advanced" (the default) needs
# V2007, V20082, V20081, V2008 and V2003 — these are added automatically
# with a warning.
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  panel = "advanced",
  vars = c("V2009", "VD4019")
)
```



***
**Options:**

  1. **save_to**: The directory in which the user desires to save the downloaded files.


  2. **years**: picks the years for which the data will be downloaded
 

  3. **quarters**: The quarters within those years to be downloaded. Can be either a vector such as `1:4` for consistent quarters across years, or a list of vectors, if quarters are different for each year (e.g. `list(1:4, 1:2)` for four quarters in the first year and two in the second).


  4. **panel**: Which panel algorithm to apply to this data. There are three options:
     * `none`: No panel is built. If `raw_data = TRUE`, returns the original data. Otherwise, creates some extra treated variables. The intermediate quarters parquet is always kept when `panel = "none"`.
     * `basic`: Performs basic identification steps for creating households and individual identifiers for panel construction
     * `advanced`: Performs advanced identification steps for creating households and individual identifiers for panel construction.
  
  
  5. **raw_data**: A command to define if the user would like to download the raw or treated data. There are two options:
     * `TRUE`: if you want the PNADC variables as they come.
     * `FALSE`: if you want the treated version of the PNADC variables.

  6. **save_options**: A logical vector of length 2 controlling file saving behaviour:
     * `c(TRUE, TRUE)` (default): keeps the intermediate quarters parquet after panel is built; saves panel files as `.csv`.
     * `c(FALSE, TRUE)`: deletes the quarters parquet after use; saves panel files as `.csv`.
     * `c(TRUE, FALSE)`: keeps the quarters parquet; saves panel files as a `.parquet` dataset.
     * `c(FALSE, FALSE)`: deletes the quarters parquet after use; saves panel files as a `.parquet` dataset.

  7. **vars**: A character vector of additional variable names to download, following the same convention as `vars` in `PNADcIBGE::get_pnadc()`. Use `NULL` (the default) to download all available microdata columns. See the note above regarding the ~210 structural columns that are always returned by `PNADcIBGE::get_pnadc()` regardless of this argument.
     
***
**Details:**

The function performs the following steps:
  

  1. Loop over years and quarters using `PNADcIBGE::get_pnadc` to download the data. All quarters are collected in memory and saved together into a single `pnadc_quarters.parquet` file in `save_to`.
  
  2. Split the data into panels by the panel variable `V1014`. Data from each panel is saved depending on `save_options`.
  
  3. Read each panel file and apply the identification algorithms defined in `build_pnadc_panel`.
  
  4. If `save_options[1] = FALSE`, the intermediate quarters parquet is deleted after the panels are built.

  
* The identification algorithms in `build_pnadc_panel` are drawn from Ribas, Rafael Perez, and Sergei Suarez Dillon Soares (2008): "Sobre o painel da Pesquisa Mensal de Emprego (PME) do IBGE".
  
***

---
title: "LOAD_PNADC"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{LOAD_PNADC}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

```

The `load_pnadc` function is a wrapper for *[`get_pnadc`](https://www.rdocumentation.org/packages/PNADcIBGE/versions/0.7.0/topics/get_pnadc)* from the package `PNADcIBGE`, with added identification algorithms for panel construction. For details on the identification algorithms, see `vignette("BUILD_PNADC_PANEL")`.

---
  
**Panel Structure:**

The table below shows the first and last quarter (`ANOtrimestre`, e.g. `20121` = 2012 Q1) covered by each PNADC rotating panel:
  
| Panel | Start |  End  |
| ----: | ----- | ----- |
|     1 | 20121 | 20124 |
|     2 | 20121 | 20141 |
|     3 | 20132 | 20152 |
|     4 | 20143 | 20163 |
|     5 | 20154 | 20174 |
|     6 | 20171 | 20191 |
|     7 | 20182 | 20202 |
|     8 | 20193 | 20213 |
|     9 | 20204 | 20224 |
|    10 | 20221 | 20241 |
|    11 | 20232 | 20252 |
|    12 | 20243 | 20263 |
|    13 | 20254 | 20274 |
|    14 | 20271 | 20291 |

  ---

**Usage:**

Default:

```{r eval=FALSE}

load_pnadc(
  save_to = getwd(),
  years,
  quarters = 1:4,
  panel = "advanced_3",
  raw_data = FALSE,
  save_options = c(TRUE, TRUE),
  vars = NULL
)


```

To download PNADC data for all quarters of 2022 and 2023, with advanced fuzzy identification (Stage 3), simply run:

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022:2023,
  panel = "advanced_3"
)

```

To download PNADC data for all of 2022, but only the first quarter of 2023, run:

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022:2023,
  quarters = list(1:4, 1)
)

```

To download PNADC data without any variables treatment or identification (e.g., for all quarters of 2021), run:

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2021,
  panel = "none",
  raw_data = TRUE
)

```

To download PNADC data, save quarters on disk, and save panels as Parquet, run:

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  save_options = c(TRUE, FALSE)
)

```

To download PNADC data and save panels as RDS but discard the quarterly files, run:

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  save_options = c(FALSE, TRUE)
)

```

To download only a specific subset of variables — for example, age (`V2009`) and habitual income (`VD4019`) — alongside the structural columns that `PNADcIBGE` always returns, run:

```{r eval=FALSE}
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  vars = c("V2009", "VD4019")
)

```

> **Note:** `PNADcIBGE::get_pnadc()` always downloads a set of ~210 structural
> columns regardless of the `vars` argument. These include survey design weights
> (`V1027`, `V1028`, `V1028001`–`V1028200`, `posest`, `posest_sxi`), deflator
> variables (`Habitual`, `Efetivo`), and identifiers such as `UF`, `Estrato`,
> `V1029`, `V1033`, and `ID_DOMICILIO`. The `vars` argument adds columns
> **on top of** those; it does not restrict them. Use `vars = NULL` (the
> default) to download all available microdata columns.

If you specify `vars` and also request panel identification, any columns
required by the identification algorithm that are absent from `vars` will be
added automatically and a warning will tell you which ones were added. For
example, when using `panel = "advanced_3"`, the columns `V2007`, `V20082`,
`V20081`, `V2008`, and `V2003` must be present. If you omit them from `vars`,
the function adds them for you:

```{r eval=FALSE}
# Only V2009 requested, but panel = "advanced_3" needs
# V2007, V20082, V20081, V2008 and V2003 — these are added automatically
# with a warning.
load_pnadc(
  save_to = "Directory/You/Would/like/to/save/the/files",
  years = 2022,
  panel = "advanced_3",
  vars = c("V2009", "VD4019")
)

```

---
  
**Options:**

  1. **save_to**: The directory in which the user desires to save the downloaded files.


  2. **years**: picks the years for which the data will be downloaded
 

  3. **quarters**: The quarters within those years to be downloaded. Can be either a vector such as `1:4` for consistent quarters across years, or a list of vectors, if quarters are different for each year (e.g. `list(1:4, 1:2)` for four quarters in the first year and two in the second).


  4. **panel**: Which panel algorithm to apply to this data. There are five options:
  
     * `none`: No panel is built. If `raw_data = TRUE`, returns the original data. Otherwise, creates some extra treated variables. Quarterly files are saved depending on `save_options`.
     * `basic`: Performs basic identification steps using household IDs, sex, and exact dates of birth.
     * `advanced_1`: Performs Stage 1 advanced identification, imputing missing birth dates using within-household donors.
     * `advanced_2`: Performs Stage 2 advanced identification, relaxing the year of birth constraint.
     * `advanced_3` (Recommended): Performs Stage 3 advanced identification, utilizing Graph Theory for fuzzy matching of fragmented interviews to account for typographical errors.
  
  
  5. **raw_data**: A command to define if the user would like to download the raw or treated data. There are two options:
  
     * `TRUE`: if you want the PNADC variables as they come.
     * `FALSE`: if you want the treated version of the PNADC variables.

  6. **save_options**: A logical vector of length 2 controlling file saving behavior:
  
     * `c(TRUE, TRUE)` (default): saves quarterly and panel files as `.rds`.
     * `c(FALSE, TRUE)`: does not save quarterly files; saves panel files as `.rds`.
     * `c(TRUE, FALSE)`: saves quarterly and panel files as `.parquet` datasets.
     * `c(FALSE, FALSE)`: does not save quarterly files; saves panel files as a `.parquet` dataset.

  7. **vars**: A character vector of additional variable names to download, following the same convention as `vars` in `PNADcIBGE::get_pnadc()`. Use `NULL` (the default) to download all available microdata columns. See the note above regarding the ~210 structural columns that are always returned by `PNADcIBGE::get_pnadc()` regardless of this argument

---
  
**Details:**

The function performs the following steps:
  
1. Loop over years and quarters using `PNADcIBGE::get_pnadc` to download the data. All quarters are collected in memory and saved depending on `save_options`.
2. Split the data into panels by the panel variable `V1014`.
3. Apply the identification algorithms defined in `build_pnadc_panel`.
4. Save the panel files as `.rds` or `.parquet`, depending on `save_options`.

* The base identification logic in `build_pnadc_panel` was originally drawn from Ribas, Rafael Perez, and Sergei Suarez Dillon Soares (2008): "Sobre o painel da Pesquisa Mensal de Emprego (PME) do IBGE", with extensive modernizations, missing-data imputation, and graph-based fuzzy matching introduced by the Data Zoom team.

---

---
title: 'BUILD_PNADC_PANEL'
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{BUILD_PNADC_PANEL}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

library(datazoom.social)
```

***
**Usage:**

Basic Panel

```{r eval=TRUE}

panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "basic")

```

Advanced Panel

```{r eval=TRUE}

panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced")

```

***
**Description**

Our `load_pnadc` function uses the internal function `build_pnadc_panel` to identify households and individuals across quarters. The method used for the identification is based on the paper of Ribas, Rafael Perez, and Sergei Suarez Dillon Soares (2008): "Sobre o painel da Pesquisa Mensal de Emprego (PME) do IBGE". 

***

## Basic Identification

The household identifier -- stored as `id_dom` -- combines the variables:

* `UPA` -- Primary Sampling Unit - PSU;

* `V1008` -- Household;

* `V1014` -- Panel Number;

In order to create a unique number for every combination of those variables.

***

The basic individual identifier -- stored as `id_ind` -- combines the household id with:

* `V2007` -- Sex;

* Date of Birth -- [`V20082` (year), `V20081` (month), `V2008` (day)];

In order to create an unique number for every combination of those variables.

***

## Advanced Identification

The advanced identifier is saved as `id_rs`. On individuals who were not matched on all interviews, we relax some assumptions to increase matching power. Under the assumption that the date of birth is often misreported, we take individuals who are either:

1. Head of the household or their partner

2. Child of the head of the household, 25 or older

For these observations, we run the basic identification again, but allowing the year of birth to be wrong. We also include the order number.

## Attrition

The tables below show the levels of attrition obtained using the basic and advanced identification algorithms, and compares them to the attrition levels obtained in the Stata `datazoom_social` package.

```{r, echo = FALSE}
knitr::kable(
  datazoom.social:::atrito,
  col.names = c(
    "Interview",
    "Percentage found (R)",
    "Percentage found (Stata)"
  ),
  caption = "Attrition for Panel 2"
)
```

Each cell is the percentage of PNADC observations that are identified by the advanced algorithm in each interview.

---
title: 'BUILD_PNADC_PANEL'
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{BUILD_PNADC_PANEL}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

library(datazoom.social)

```

---
  
**Usage:**

Basic Panel:

```{r eval=FALSE}
panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "basic")

```

Advanced Panel (Stages 1, 2, or 3):

```{r eval=FALSE}
# Stage 1: Exact matching with donated birth dates
panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced_1")

# Stage 2: Relaxed matching constraints
panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced_2")

# Stage 3: Fuzzy matching using Graph Theory (Recommended)
panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced_3")

```

---
  
**Description**

Our `load_pnadc` function uses the internal function `build_pnadc_panel` to identify households and individuals across quarters. The base method used for the identification draws from the paper of Ribas, Rafael Perez, and Sergei Suarez Dillon Soares (2008): "Sobre o painel da Pesquisa Mensal de Emprego (PME) do IBGE", with modernizations implemented by the Data Zoom team to handle missing data and typographical errors.

---
  
## Basic Identification

The household identifier -- stored as `id_dom` -- combines the variables:

  * `UPA` -- Primary Sampling Unit - PSU;
  * `V1008` -- Household;
  * `V1014` -- Panel Number;

In order to create a unique number for every combination of those variables.

---

The basic individual identifier -- stored as `id_ind` -- combines the household id with:

  * `V2007` -- Sex;
  * Date of Birth -- [`V20082` (year), `V20081` (month), `V2008` (day)];

In order to create a unique number for every combination of those variables.

---
  
## Advanced Identification

On individuals who were not matched across all interviews using the basic method, we apply a progressive multi-stage algorithm to increase matching power without compromising uniqueness.

* **Stage 1 (`advanced_1`):** We reproduce the birth date donation method (Osório, 2019). It estimates and imputes missing birth dates (day, month, and year) by matching individuals with donors from different interviews within the same household based on sex, acceptable household condition changes, and estimated age. The identifier is stored as `id_rs1`.
* **Stage 2 (`advanced_2`):** For individuals not completely matched in Stage 1, we relax the year of birth constraint (assuming it is often misreported) and match individuals based on Household ID, Month, and Day of birth. The identifier is stored as `id_rs2`.
* **Stage 3 (`advanced_3`):** Applies a rigorous Fuzzy Matching algorithm using Graph Theory (via the `igraph` package). Targeting candidates with fragmented interviews, it evaluates pairwise combinations within the same household. It tolerates small typographical errors (up to 4 days difference in the day of birth, 2 months in the month of birth) and dynamically adjusts the acceptable year-of-birth difference based on the individual's reported age. The final identifier is stored as `id_rs3`.

## Identification Rates

The table below shows the average unconditional tracking rates (base line) obtained using the basic and advanced identification algorithms across multiple panels.

*Note: Following the Data Zoom methodological guidelines, we reserve the term **Attrition** strictly for the dropout of households. When referring to individuals (people), we use the term **Identification Rate**. Wave 1 represents the pure initial identification rate (data lost exclusively due to the inability to construct a valid identifier or household grouping constraints). The subsequent waves (2 to 5) represent the cumulative loss of tracked data over time.*

| Interview (Wave) | Basic Rate (%) | Adv 1 Rate (%) | Adv 2 Rate (%) | Adv 3 Rate (%) | Difference (Adv 3 - Basic) |
| :---: | :---: | :---: | :---: | :---: | :---: |
| 1 | 93.82378 | 95.82954 | 96.40170 | 96.39606 | + 2.57228 p.p. |
| 2 | 81.63945 | 84.52960 | 85.32100 | 85.63223 | + 3.99278 p.p. |
| 3 | 75.58231 | 78.90345 | 79.87407 | 80.37762 | + 4.79531 p.p. |
| 4 | 71.13217 | 74.66729 | 75.75082 | 76.39818 | + 5.26601 p.p. |
| 5 | 67.56865 | 71.18041 | 72.31560 | 73.06694 | + 5.49829 p.p. |

Each cell in the rate columns represents the percentage of raw PNADC individual observations successfully identified and tracked in that specific interview, using the total number of raw lines from Wave 1 as the universal denominator.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pnad_sample.R
\docType{data}
\name{pnad_sample}
\alias{pnad_sample}
\title{Simulated PNAD sample dataset}
\format{
A \code{data.table} and \code{data.frame} with 31 rows and 23 variables:
\describe{
\item{V1}{Record identifier.}
\item{Ano}{Survey year.}
\item{Trimestre}{Survey quarter.}
\item{UF}{Federative unit code.}
\item{UPA}{Primary sampling unit identifier.}
\item{V1008}{Household serial identifier.}
\item{V1014}{Number of household members.}
\item{V1016}{Household interview status or type code.}
\item{V20082}{Year of birth.}
\item{V20081}{Month of birth.}
\item{V2008}{Day of birth or age-related auxiliary code, as provided in the simulated data.}
\item{V2007}{Sex code.}
\item{V2009}{Age in years.}
\item{VD3004}{Educational attainment code.}
\item{VD4001}{Labor force status code.}
\item{VD4002}{Employment status code.}
\item{VD4005}{Employment position or job category code.}
\item{VD4009}{Usual hours worked category or related labor variable code.}
\item{VD4019}{Monthly labor income.}
\item{V4010}{Main job identifier or occupation-related code.}
\item{V4012}{Economic activity or occupation grouping code.}
\item{V4013}{Time in job or age-related auxiliary labor code.}
\item{V4022}{Household or person weight, as represented in the simulated data.}
}
}
\source{
Inspired by the structure of PNAD Contínua microdata produced by the
Brazilian Institute of Geography and Statistics (IBGE).
\url{https://www.ibge.gov.br}
}
\usage{
pnad_sample
}
\description{
A small simulated dataset inspired by microdata from the Brazilian
Continuous National Household Sample Survey (PNAD Contínua), included for
examples, tests, and documentation in the \code{datazoom.social} package.
}
\details{
This dataset does not contain real PNAD observations. It was created only
for demonstration purposes and includes a small subset of variables from the
original files distributed by IBGE. Its reduced size makes package examples
faster and lighter, while preserving a structure similar to that of the
original survey data.

The purpose of \code{pnad_sample} is to provide a lightweight object that mimics
part of the structure of PNAD Contínua microdata, allowing users to run
examples without downloading or processing the full original files.

Variable names follow the naming convention used in the original survey
microdata, but the values in this dataset are simulated and should not be
used for substantive empirical analysis.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/load_pnadc.R
\name{load_pnadc}
\alias{load_pnadc}
\title{Load Continuous PNAD Data}
\usage{
load_pnadc(
  save_to,
  years,
  quarters = 1:4,
  panel = "advanced",
  raw_data = FALSE,
  save_options = c(TRUE, TRUE),
  vars = NULL
)
}
\arguments{
\item{save_to}{A \code{character} with the directory in which to save the downloaded files.}

\item{years}{A \code{numeric} indicating for which years the data will be loaded, in the format YYYY. Can be any vector of numbers, such as 2010:2012.}

\item{quarters}{The quarters within those years to be downloaded. Can be a numeric vector or a list of vectors, for different quarters per year.}

\item{panel}{A \code{character} choosing the panel algorithm to apply ("none", "basic", or "advanced"). For details, check \code{vignette("BUILD_PNADC_PANEL")}}

\item{raw_data}{A \code{logical} setting the return of raw (\code{TRUE}) or processed (\code{FALSE}) variables.}

\item{save_options}{A \code{logical} vector of length 2. Controls whether quarterly
files are saved and in which format all files are saved. Panel files are
always saved. There are four possible combinations:
\itemize{
\item \code{c(TRUE, TRUE)}: saves quarterly and panel files in
\code{.rds} format. This is the default.
\item \code{c(TRUE, FALSE)}: saves quarterly and panel files in
\code{.parquet} format.
\item \code{c(FALSE, TRUE)}: does not save quarterly files; panel files
are saved in \code{.rds} format.
\item \code{c(FALSE, FALSE)}: does not save quarterly files; panel files
are saved in \code{.parquet} format.
}}

\item{vars}{A \code{character} vector of additional variable names to be
downloaded, following the same convention as the \code{vars} parameter in
\code{\link[PNADcIBGE]{get_pnadc}}. Each name must match a column in the
PNADC microdata exactly as published by IBGE (e.g. \code{"VD4019"},
\code{"V2009"}).

Note that \code{\link[PNADcIBGE]{get_pnadc}} always returns a set of
structural columns regardless of this argument, these include survey
design weights (\code{V1027}, \code{V1028}, \code{V1028001}, \code{V1028200},
\code{posest}, \code{posest_sxi}), deflator variables (\code{Habitual},
\code{Efetivo}), and identifiers such as \code{UF}, \code{Estrato},
\code{V1029}, \code{V1033}, \code{ID_DOMICILIO}, totalling around 233
columns. The \code{vars} argument adds \emph{on top of} those columns;
it does not restrict them. Use \code{NULL} (the default) to download all
available microdata columns.

If \code{panel} is not \code{"none"}, any columns required by the panel
identification algorithm that are missing from \code{vars} will be added
automatically and a \code{\link{warning}} will list the columns that were
added. The required columns per algorithm are:
\itemize{
\item \code{"basic"}: \code{UPA}, \code{V1008}, \code{V1014},
\code{V2007}, \code{V20082}, \code{V20081}, \code{V2008}.
\item \code{"advanced"}: all of the above, plus \code{V2003}.
}
Note that several of these (\code{UPA}, \code{V1008}, \code{V1014}) are
part of the structural columns always returned by
\code{\link[PNADcIBGE]{get_pnadc}}, so in practice only \code{V2007},
\code{V20082}, \code{V20081}, \code{V2008} (and \code{V2003} for
\code{"advanced"}) are likely to be auto-added.}
}
\value{
A message indicating the successful save of panel files.
}
\description{
This function downloads PNADC data and applies panel identification algorithms
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
### DO NOT RUN ###
load_pnadc(
  save_to = tempdir(),
  years = 2016,
  quarters = 1:4,
  panel = "advanced",
  raw_data = FALSE,
  save_options = c(FALSE, FALSE)
)
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/build_pnadc_panel.R
\name{build_pnadc_panel}
\alias{build_pnadc_panel}
\title{Build PNADc Panel}
\usage{
build_pnadc_panel(dat, panel)
}
\arguments{
\item{dat}{Data frame with PNADC data, sorted into a single panel.}

\item{panel}{A \code{character} with the type of panel identification. Use "none" for no paneling, "basic" for basic paneling, "advanced_1" for advanced stage 1 paneling, "advanced_2" for advanced stage 2 paneling, and "advanced_3" for the fuzzy-matching stage 3 paneling.}
}
\value{
A modified dataset with added identifiers for household (\code{id_dom}) and individual (\code{id_ind}, and progressively \code{id_rs1}, \code{id_rs2}, or \code{id_rs3}) based on the chosen panel algorithm.
}
\description{
This function builds a panel dataset from PNADC data, identifying households and individuals.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
# Example usage:

panel_data <- build_pnadc_panel(dat = pnad_sample, panel = "advanced_3")
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cria_df_de_atrito.R
\name{cria_df_de_atrito}
\alias{cria_df_de_atrito}
\title{Create an attrition table for a panel file}
\usage{
cria_df_de_atrito(data, panel)
}
\arguments{
\item{data}{The input data frame, preferably a PNADc panel file.}

\item{panel}{The identification strategy: "basic", "advanced_1", "advanced_2", "advanced_3" or "households".}
}
\value{
A data frame summarizing missing interviews and the tracking rates.
}
\description{
This function generates a summary dataframe indicating the count of missing
interviews for each individual and the unconditional tracking rates.
}
